{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation getTerminalConfigurationsConfiguration
module StripeAPI.Operations.GetTerminalConfigurationsConfiguration where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > GET /v1/terminal/configurations/{configuration}
--
-- \<p>Retrieves a \<code>Configuration\<\/code> object.\<\/p>
getTerminalConfigurationsConfiguration ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | Contains all available parameters of this operation (query and path parameters)
  GetTerminalConfigurationsConfigurationParameters ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response GetTerminalConfigurationsConfigurationResponse)
getTerminalConfigurationsConfiguration parameters =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either GetTerminalConfigurationsConfigurationResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetTerminalConfigurationsConfigurationResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            GetTerminalConfigurationsConfigurationResponseBody200
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetTerminalConfigurationsConfigurationResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET") (Data.Text.pack ("/v1/terminal/configurations/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel (getTerminalConfigurationsConfigurationParametersPathConfiguration parameters))) GHC.Base.++ ""))) [StripeAPI.Common.QueryParameter (Data.Text.pack "expand") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getTerminalConfigurationsConfigurationParametersQueryExpand parameters) (Data.Text.pack "deepObject") GHC.Types.True])

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.GET.parameters@ in the specification.
data GetTerminalConfigurationsConfigurationParameters = GetTerminalConfigurationsConfigurationParameters
  { -- | pathConfiguration: Represents the parameter named \'configuration\'
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getTerminalConfigurationsConfigurationParametersPathConfiguration :: Data.Text.Internal.Text,
    -- | queryExpand: Represents the parameter named \'expand\'
    --
    -- Specifies which fields in the response should be expanded.
    getTerminalConfigurationsConfigurationParametersQueryExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text]))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetTerminalConfigurationsConfigurationParameters where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["pathConfiguration" Data.Aeson.Types.ToJSON..= getTerminalConfigurationsConfigurationParametersPathConfiguration obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryExpand" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationParametersQueryExpand obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["pathConfiguration" Data.Aeson.Types.ToJSON..= getTerminalConfigurationsConfigurationParametersPathConfiguration obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryExpand" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationParametersQueryExpand obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON GetTerminalConfigurationsConfigurationParameters where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetTerminalConfigurationsConfigurationParameters" (\obj -> (GHC.Base.pure GetTerminalConfigurationsConfigurationParameters GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "pathConfiguration")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryExpand"))

-- | Create a new 'GetTerminalConfigurationsConfigurationParameters' with all required fields.
mkGetTerminalConfigurationsConfigurationParameters ::
  -- | 'getTerminalConfigurationsConfigurationParametersPathConfiguration'
  Data.Text.Internal.Text ->
  GetTerminalConfigurationsConfigurationParameters
mkGetTerminalConfigurationsConfigurationParameters getTerminalConfigurationsConfigurationParametersPathConfiguration =
  GetTerminalConfigurationsConfigurationParameters
    { getTerminalConfigurationsConfigurationParametersPathConfiguration = getTerminalConfigurationsConfigurationParametersPathConfiguration,
      getTerminalConfigurationsConfigurationParametersQueryExpand = GHC.Maybe.Nothing
    }

-- | Represents a response of the operation 'getTerminalConfigurationsConfiguration'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'GetTerminalConfigurationsConfigurationResponseError' is used.
data GetTerminalConfigurationsConfigurationResponse
  = -- | Means either no matching case available or a parse error
    GetTerminalConfigurationsConfigurationResponseError GHC.Base.String
  | -- | Successful response.
    GetTerminalConfigurationsConfigurationResponse200 GetTerminalConfigurationsConfigurationResponseBody200
  | -- | Error response.
    GetTerminalConfigurationsConfigurationResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.GET.responses.200.content.application\/json.schema.anyOf@ in the specification.
data GetTerminalConfigurationsConfigurationResponseBody200 = GetTerminalConfigurationsConfigurationResponseBody200
  { -- | bbpos_wisepos_e:
    getTerminalConfigurationsConfigurationResponseBody200BbposWiseposE :: (GHC.Maybe.Maybe TerminalConfigurationConfigurationResourceDeviceTypeSpecificConfig),
    -- | deleted: Always true for a deleted object
    getTerminalConfigurationsConfigurationResponseBody200Deleted :: (GHC.Maybe.Maybe GetTerminalConfigurationsConfigurationResponseBody200Deleted'),
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getTerminalConfigurationsConfigurationResponseBody200Id :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | is_account_default: Whether this Configuration is the default for your account
    getTerminalConfigurationsConfigurationResponseBody200IsAccountDefault :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Bool)),
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    getTerminalConfigurationsConfigurationResponseBody200Livemode :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | object: String representing the object\'s type. Objects of the same type share the same value.
    getTerminalConfigurationsConfigurationResponseBody200Object :: (GHC.Maybe.Maybe GetTerminalConfigurationsConfigurationResponseBody200Object'),
    -- | tipping:
    getTerminalConfigurationsConfigurationResponseBody200Tipping :: (GHC.Maybe.Maybe TerminalConfigurationConfigurationResourceTipping),
    -- | verifone_p400:
    getTerminalConfigurationsConfigurationResponseBody200VerifoneP400 :: (GHC.Maybe.Maybe TerminalConfigurationConfigurationResourceDeviceTypeSpecificConfig)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetTerminalConfigurationsConfigurationResponseBody200 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200BbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("deleted" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Deleted obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("id" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Id obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("is_account_default" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200IsAccountDefault obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("livemode" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Livemode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("object" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Object obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Tipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200VerifoneP400 obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200BbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("deleted" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Deleted obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("id" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Id obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("is_account_default" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200IsAccountDefault obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("livemode" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Livemode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("object" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Object obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200Tipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (getTerminalConfigurationsConfigurationResponseBody200VerifoneP400 obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON GetTerminalConfigurationsConfigurationResponseBody200 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetTerminalConfigurationsConfigurationResponseBody200" (\obj -> (((((((GHC.Base.pure GetTerminalConfigurationsConfigurationResponseBody200 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bbpos_wisepos_e")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "deleted")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "is_account_default")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "object")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tipping")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verifone_p400"))

-- | Create a new 'GetTerminalConfigurationsConfigurationResponseBody200' with all required fields.
mkGetTerminalConfigurationsConfigurationResponseBody200 :: GetTerminalConfigurationsConfigurationResponseBody200
mkGetTerminalConfigurationsConfigurationResponseBody200 =
  GetTerminalConfigurationsConfigurationResponseBody200
    { getTerminalConfigurationsConfigurationResponseBody200BbposWiseposE = GHC.Maybe.Nothing,
      getTerminalConfigurationsConfigurationResponseBody200Deleted = GHC.Maybe.Nothing,
      getTerminalConfigurationsConfigurationResponseBody200Id = GHC.Maybe.Nothing,
      getTerminalConfigurationsConfigurationResponseBody200IsAccountDefault = GHC.Maybe.Nothing,
      getTerminalConfigurationsConfigurationResponseBody200Livemode = GHC.Maybe.Nothing,
      getTerminalConfigurationsConfigurationResponseBody200Object = GHC.Maybe.Nothing,
      getTerminalConfigurationsConfigurationResponseBody200Tipping = GHC.Maybe.Nothing,
      getTerminalConfigurationsConfigurationResponseBody200VerifoneP400 = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.GET.responses.200.content.application\/json.schema.anyOf.properties.deleted@ in the specification.
--
-- Always true for a deleted object
data GetTerminalConfigurationsConfigurationResponseBody200Deleted'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    GetTerminalConfigurationsConfigurationResponseBody200Deleted'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    GetTerminalConfigurationsConfigurationResponseBody200Deleted'Typed GHC.Types.Bool
  | -- | Represents the JSON value @true@
    GetTerminalConfigurationsConfigurationResponseBody200Deleted'EnumTrue
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GetTerminalConfigurationsConfigurationResponseBody200Deleted' where
  toJSON (GetTerminalConfigurationsConfigurationResponseBody200Deleted'Other val) = val
  toJSON (GetTerminalConfigurationsConfigurationResponseBody200Deleted'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (GetTerminalConfigurationsConfigurationResponseBody200Deleted'EnumTrue) = Data.Aeson.Types.Internal.Bool GHC.Types.True

instance Data.Aeson.Types.FromJSON.FromJSON GetTerminalConfigurationsConfigurationResponseBody200Deleted' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== Data.Aeson.Types.Internal.Bool GHC.Types.True -> GetTerminalConfigurationsConfigurationResponseBody200Deleted'EnumTrue
            | GHC.Base.otherwise -> GetTerminalConfigurationsConfigurationResponseBody200Deleted'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.GET.responses.200.content.application\/json.schema.anyOf.properties.object@ in the specification.
--
-- String representing the object\'s type. Objects of the same type share the same value.
data GetTerminalConfigurationsConfigurationResponseBody200Object'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    GetTerminalConfigurationsConfigurationResponseBody200Object'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    GetTerminalConfigurationsConfigurationResponseBody200Object'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"terminal.configuration"@
    GetTerminalConfigurationsConfigurationResponseBody200Object'EnumTerminal'configuration
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GetTerminalConfigurationsConfigurationResponseBody200Object' where
  toJSON (GetTerminalConfigurationsConfigurationResponseBody200Object'Other val) = val
  toJSON (GetTerminalConfigurationsConfigurationResponseBody200Object'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (GetTerminalConfigurationsConfigurationResponseBody200Object'EnumTerminal'configuration) = "terminal.configuration"

instance Data.Aeson.Types.FromJSON.FromJSON GetTerminalConfigurationsConfigurationResponseBody200Object' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "terminal.configuration" -> GetTerminalConfigurationsConfigurationResponseBody200Object'EnumTerminal'configuration
            | GHC.Base.otherwise -> GetTerminalConfigurationsConfigurationResponseBody200Object'Other val
      )
