{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postTerminalConfigurations
module StripeAPI.Operations.PostTerminalConfigurations where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/terminal/configurations
--
-- \<p>Creates a new \<code>Configuration\<\/code> object.\<\/p>
postTerminalConfigurations ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | The request body to send
  GHC.Maybe.Maybe PostTerminalConfigurationsRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostTerminalConfigurationsResponse)
postTerminalConfigurations body =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either PostTerminalConfigurationsResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostTerminalConfigurationsResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Terminal'configuration
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostTerminalConfigurationsResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack "/v1/terminal/configurations") GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostTerminalConfigurationsRequestBody = PostTerminalConfigurationsRequestBody
  { -- | bbpos_wisepos_e: An object containing device type specific settings for BBPOS WisePOS E readers
    postTerminalConfigurationsRequestBodyBbposWiseposE :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyBbposWiseposE'),
    -- | expand: Specifies which fields in the response should be expanded.
    postTerminalConfigurationsRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | tipping: Tipping configurations for readers supporting on-reader tips
    postTerminalConfigurationsRequestBodyTipping :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'Variants),
    -- | verifone_p400: An object containing device type specific settings for Verifone P400 readers
    postTerminalConfigurationsRequestBodyVerifoneP400 :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyVerifoneP400')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyBbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyVerifoneP400 obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyBbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyVerifoneP400 obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBody" (\obj -> (((GHC.Base.pure PostTerminalConfigurationsRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bbpos_wisepos_e")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tipping")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verifone_p400"))

-- | Create a new 'PostTerminalConfigurationsRequestBody' with all required fields.
mkPostTerminalConfigurationsRequestBody :: PostTerminalConfigurationsRequestBody
mkPostTerminalConfigurationsRequestBody =
  PostTerminalConfigurationsRequestBody
    { postTerminalConfigurationsRequestBodyBbposWiseposE = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyExpand = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyVerifoneP400 = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.bbpos_wisepos_e@ in the specification.
--
-- An object containing device type specific settings for BBPOS WisePOS E readers
data PostTerminalConfigurationsRequestBodyBbposWiseposE' = PostTerminalConfigurationsRequestBodyBbposWiseposE'
  { -- | splashscreen
    postTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyBbposWiseposE' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyBbposWiseposE' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyBbposWiseposE'" (\obj -> GHC.Base.pure PostTerminalConfigurationsRequestBodyBbposWiseposE' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "splashscreen"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyBbposWiseposE'' with all required fields.
mkPostTerminalConfigurationsRequestBodyBbposWiseposE' :: PostTerminalConfigurationsRequestBodyBbposWiseposE'
mkPostTerminalConfigurationsRequestBodyBbposWiseposE' = PostTerminalConfigurationsRequestBodyBbposWiseposE' {postTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen = GHC.Maybe.Nothing}

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.bbpos_wisepos_e.properties.splashscreen.anyOf@ in the specification.
data PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'EmptyString
  | PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'Variants where
  toJSON (PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsRequestBodyBbposWiseposE'Splashscreen'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1 = PostTerminalConfigurationsRequestBodyTipping'OneOf1
  { -- | aud
    postTerminalConfigurationsRequestBodyTipping'OneOf1Aud :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud'),
    -- | cad
    postTerminalConfigurationsRequestBodyTipping'OneOf1Cad :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad'),
    -- | chf
    postTerminalConfigurationsRequestBodyTipping'OneOf1Chf :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf'),
    -- | czk
    postTerminalConfigurationsRequestBodyTipping'OneOf1Czk :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk'),
    -- | dkk
    postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'),
    -- | eur
    postTerminalConfigurationsRequestBodyTipping'OneOf1Eur :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur'),
    -- | gbp
    postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'),
    -- | hkd
    postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'),
    -- | myr
    postTerminalConfigurationsRequestBodyTipping'OneOf1Myr :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr'),
    -- | nok
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nok :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok'),
    -- | nzd
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'),
    -- | sek
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sek :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek'),
    -- | sgd
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'),
    -- | usd
    postTerminalConfigurationsRequestBodyTipping'OneOf1Usd :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("aud" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cad" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("chf" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("czk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dkk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eur" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("gbp" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hkd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("myr" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nok" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nzd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sek" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sgd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("usd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("aud" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cad" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("chf" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("czk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dkk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eur" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("gbp" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hkd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("myr" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nok" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nzd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sek" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sgd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("usd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1" (\obj -> (((((((((((((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "aud")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "cad")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "chf")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "czk")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "dkk")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "eur")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "gbp")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "hkd")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "myr")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "nok")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "nzd")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sek")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sgd")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "usd"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1 :: PostTerminalConfigurationsRequestBodyTipping'OneOf1
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1 =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Aud = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Cad = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Chf = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Czk = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Eur = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Myr = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Nok = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Sek = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Usd = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.aud@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Aud' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Aud' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Aud'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Aud'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.cad@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Cad' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Cad' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Cad'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Cad'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.chf@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Chf' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Chf' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Chf'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Chf'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.czk@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Czk' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Czk' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Czk'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Czk'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.dkk@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Dkk'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.eur@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Eur' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Eur' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Eur'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Eur'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.gbp@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Gbp'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.hkd@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Hkd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.myr@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Myr' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Myr' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Myr'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Myr'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.nok@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Nok' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Nok' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Nok'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Nok'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.nzd@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Nzd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.sek@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Sek' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Sek' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Sek'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Sek'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.sgd@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Sgd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.usd@ in the specification.
data PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd' = PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd'
  { -- | fixed_amounts
    postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd'' with all required fields.
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Usd' :: PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd'
mkPostTerminalConfigurationsRequestBodyTipping'OneOf1Usd' =
  PostTerminalConfigurationsRequestBodyTipping'OneOf1Usd'
    { postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsRequestBodyTipping'OneOf1Usd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf@ in the specification.
--
-- Tipping configurations for readers supporting on-reader tips
data PostTerminalConfigurationsRequestBodyTipping'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsRequestBodyTipping'EmptyString
  | PostTerminalConfigurationsRequestBodyTipping'PostTerminalConfigurationsRequestBodyTipping'OneOf1 PostTerminalConfigurationsRequestBodyTipping'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyTipping'Variants where
  toJSON (PostTerminalConfigurationsRequestBodyTipping'PostTerminalConfigurationsRequestBodyTipping'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsRequestBodyTipping'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyTipping'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsRequestBodyTipping'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsRequestBodyTipping'PostTerminalConfigurationsRequestBodyTipping'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.verifone_p400@ in the specification.
--
-- An object containing device type specific settings for Verifone P400 readers
data PostTerminalConfigurationsRequestBodyVerifoneP400' = PostTerminalConfigurationsRequestBodyVerifoneP400'
  { -- | splashscreen
    postTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen :: (GHC.Maybe.Maybe PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyVerifoneP400' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyVerifoneP400' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsRequestBodyVerifoneP400'" (\obj -> GHC.Base.pure PostTerminalConfigurationsRequestBodyVerifoneP400' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "splashscreen"))

-- | Create a new 'PostTerminalConfigurationsRequestBodyVerifoneP400'' with all required fields.
mkPostTerminalConfigurationsRequestBodyVerifoneP400' :: PostTerminalConfigurationsRequestBodyVerifoneP400'
mkPostTerminalConfigurationsRequestBodyVerifoneP400' = PostTerminalConfigurationsRequestBodyVerifoneP400' {postTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen = GHC.Maybe.Nothing}

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.verifone_p400.properties.splashscreen.anyOf@ in the specification.
data PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'EmptyString
  | PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'Variants where
  toJSON (PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsRequestBodyVerifoneP400'Splashscreen'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Represents a response of the operation 'postTerminalConfigurations'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostTerminalConfigurationsResponseError' is used.
data PostTerminalConfigurationsResponse
  = -- | Means either no matching case available or a parse error
    PostTerminalConfigurationsResponseError GHC.Base.String
  | -- | Successful response.
    PostTerminalConfigurationsResponse200 Terminal'configuration
  | -- | Error response.
    PostTerminalConfigurationsResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
