{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postTerminalConfigurationsConfiguration
module StripeAPI.Operations.PostTerminalConfigurationsConfiguration where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/terminal/configurations/{configuration}
--
-- \<p>Updates a new \<code>Configuration\<\/code> object.\<\/p>
postTerminalConfigurationsConfiguration ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | configuration | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostTerminalConfigurationsConfigurationResponse)
postTerminalConfigurationsConfiguration
  configuration
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostTerminalConfigurationsConfigurationResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTerminalConfigurationsConfigurationResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              PostTerminalConfigurationsConfigurationResponseBody200
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTerminalConfigurationsConfigurationResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/terminal/configurations/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel configuration)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBody = PostTerminalConfigurationsConfigurationRequestBody
  { -- | bbpos_wisepos_e: An object containing device type specific settings for BBPOS WisePOS E readers
    postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'Variants),
    -- | expand: Specifies which fields in the response should be expanded.
    postTerminalConfigurationsConfigurationRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | tipping: Tipping configurations for readers supporting on-reader tips
    postTerminalConfigurationsConfigurationRequestBodyTipping :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'Variants),
    -- | verifone_p400: An object containing device type specific settings for Verifone P400 readers
    postTerminalConfigurationsConfigurationRequestBodyVerifoneP400 :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyVerifoneP400 obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyVerifoneP400 obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBody" (\obj -> (((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bbpos_wisepos_e")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tipping")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verifone_p400"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBody' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBody :: PostTerminalConfigurationsConfigurationRequestBody
mkPostTerminalConfigurationsConfigurationRequestBody =
  PostTerminalConfigurationsConfigurationRequestBody
    { postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyExpand = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyVerifoneP400 = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.bbpos_wisepos_e.anyOf@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 = PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1
  { -- | splashscreen
    postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1" (\obj -> GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "splashscreen"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 :: PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1
mkPostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 = PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 {postTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen = GHC.Maybe.Nothing}

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.bbpos_wisepos_e.anyOf.properties.splashscreen.anyOf@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'EmptyString
  | PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'Variants where
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1Splashscreen'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.bbpos_wisepos_e.anyOf@ in the specification.
--
-- An object containing device type specific settings for BBPOS WisePOS E readers
data PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'EmptyString
  | PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'Variants where
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'PostTerminalConfigurationsConfigurationRequestBodyBbposWiseposE'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1
  { -- | aud
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'),
    -- | cad
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'),
    -- | chf
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'),
    -- | czk
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'),
    -- | dkk
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'),
    -- | eur
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'),
    -- | gbp
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'),
    -- | hkd
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'),
    -- | myr
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'),
    -- | nok
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'),
    -- | nzd
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'),
    -- | sek
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'),
    -- | sgd
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'),
    -- | usd
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("aud" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cad" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("chf" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("czk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dkk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eur" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("gbp" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hkd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("myr" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nok" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nzd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sek" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sgd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("usd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("aud" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cad" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("chf" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("czk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dkk" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eur" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("gbp" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hkd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("myr" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nok" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("nzd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sek" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sgd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("usd" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1" (\obj -> (((((((((((((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "aud")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "cad")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "chf")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "czk")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "dkk")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "eur")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "gbp")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "hkd")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "myr")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "nok")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "nzd")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sek")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sgd")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "usd"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.aud@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Aud'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.cad@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Cad'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.chf@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Chf'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.czk@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Czk'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.dkk@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Dkk'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.eur@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Eur'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.gbp@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Gbp'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.hkd@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Hkd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.myr@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Myr'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.nok@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nok'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.nzd@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Nzd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.sek@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sek'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.sgd@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Sgd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf.properties.usd@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd' = PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'
  { -- | fixed_amounts
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'FixedAmounts :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | percentages
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'Percentages :: (GHC.Maybe.Maybe ([GHC.Types.Int])),
    -- | smart_tip_threshold
    postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'SmartTipThreshold :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'SmartTipThreshold obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amounts" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'FixedAmounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("percentages" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'Percentages obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("smart_tip_threshold" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'SmartTipThreshold obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'" (\obj -> ((GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "percentages")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "smart_tip_threshold"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd' :: PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'
mkPostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd' =
  PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'
    { postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'FixedAmounts = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'Percentages = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1Usd'SmartTipThreshold = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tipping.anyOf@ in the specification.
--
-- Tipping configurations for readers supporting on-reader tips
data PostTerminalConfigurationsConfigurationRequestBodyTipping'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsConfigurationRequestBodyTipping'EmptyString
  | PostTerminalConfigurationsConfigurationRequestBodyTipping'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'Variants where
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyTipping'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyTipping'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyTipping'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyTipping'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsConfigurationRequestBodyTipping'PostTerminalConfigurationsConfigurationRequestBodyTipping'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.verifone_p400.anyOf@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 = PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1
  { -- | splashscreen
    postTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("splashscreen" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1" (\obj -> GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "splashscreen"))

-- | Create a new 'PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1' with all required fields.
mkPostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 :: PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1
mkPostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 = PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 {postTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen = GHC.Maybe.Nothing}

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.verifone_p400.anyOf.properties.splashscreen.anyOf@ in the specification.
data PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'EmptyString
  | PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'Variants where
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1Splashscreen'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.verifone_p400.anyOf@ in the specification.
--
-- An object containing device type specific settings for Verifone P400 readers
data PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'Variants
  = -- | Represents the JSON value @""@
    PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'EmptyString
  | PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'Variants where
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'EmptyString
        | GHC.Base.otherwise -> case (PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'PostTerminalConfigurationsConfigurationRequestBodyVerifoneP400'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Represents a response of the operation 'postTerminalConfigurationsConfiguration'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostTerminalConfigurationsConfigurationResponseError' is used.
data PostTerminalConfigurationsConfigurationResponse
  = -- | Means either no matching case available or a parse error
    PostTerminalConfigurationsConfigurationResponseError GHC.Base.String
  | -- | Successful response.
    PostTerminalConfigurationsConfigurationResponse200 PostTerminalConfigurationsConfigurationResponseBody200
  | -- | Error response.
    PostTerminalConfigurationsConfigurationResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)

-- | Defines the object schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.responses.200.content.application\/json.schema.anyOf@ in the specification.
data PostTerminalConfigurationsConfigurationResponseBody200 = PostTerminalConfigurationsConfigurationResponseBody200
  { -- | bbpos_wisepos_e:
    postTerminalConfigurationsConfigurationResponseBody200BbposWiseposE :: (GHC.Maybe.Maybe TerminalConfigurationConfigurationResourceDeviceTypeSpecificConfig),
    -- | deleted: Always true for a deleted object
    postTerminalConfigurationsConfigurationResponseBody200Deleted :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationResponseBody200Deleted'),
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postTerminalConfigurationsConfigurationResponseBody200Id :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | is_account_default: Whether this Configuration is the default for your account
    postTerminalConfigurationsConfigurationResponseBody200IsAccountDefault :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Bool)),
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    postTerminalConfigurationsConfigurationResponseBody200Livemode :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | object: String representing the object\'s type. Objects of the same type share the same value.
    postTerminalConfigurationsConfigurationResponseBody200Object :: (GHC.Maybe.Maybe PostTerminalConfigurationsConfigurationResponseBody200Object'),
    -- | tipping:
    postTerminalConfigurationsConfigurationResponseBody200Tipping :: (GHC.Maybe.Maybe TerminalConfigurationConfigurationResourceTipping),
    -- | verifone_p400:
    postTerminalConfigurationsConfigurationResponseBody200VerifoneP400 :: (GHC.Maybe.Maybe TerminalConfigurationConfigurationResourceDeviceTypeSpecificConfig)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationResponseBody200 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200BbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("deleted" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Deleted obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("id" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Id obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("is_account_default" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200IsAccountDefault obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("livemode" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Livemode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("object" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Object obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Tipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200VerifoneP400 obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bbpos_wisepos_e" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200BbposWiseposE obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("deleted" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Deleted obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("id" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Id obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("is_account_default" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200IsAccountDefault obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("livemode" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Livemode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("object" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Object obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tipping" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200Tipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verifone_p400" Data.Aeson.Types.ToJSON..=)) (postTerminalConfigurationsConfigurationResponseBody200VerifoneP400 obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationResponseBody200 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTerminalConfigurationsConfigurationResponseBody200" (\obj -> (((((((GHC.Base.pure PostTerminalConfigurationsConfigurationResponseBody200 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bbpos_wisepos_e")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "deleted")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "is_account_default")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "object")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tipping")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verifone_p400"))

-- | Create a new 'PostTerminalConfigurationsConfigurationResponseBody200' with all required fields.
mkPostTerminalConfigurationsConfigurationResponseBody200 :: PostTerminalConfigurationsConfigurationResponseBody200
mkPostTerminalConfigurationsConfigurationResponseBody200 =
  PostTerminalConfigurationsConfigurationResponseBody200
    { postTerminalConfigurationsConfigurationResponseBody200BbposWiseposE = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationResponseBody200Deleted = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationResponseBody200Id = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationResponseBody200IsAccountDefault = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationResponseBody200Livemode = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationResponseBody200Object = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationResponseBody200Tipping = GHC.Maybe.Nothing,
      postTerminalConfigurationsConfigurationResponseBody200VerifoneP400 = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.responses.200.content.application\/json.schema.anyOf.properties.deleted@ in the specification.
--
-- Always true for a deleted object
data PostTerminalConfigurationsConfigurationResponseBody200Deleted'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostTerminalConfigurationsConfigurationResponseBody200Deleted'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostTerminalConfigurationsConfigurationResponseBody200Deleted'Typed GHC.Types.Bool
  | -- | Represents the JSON value @true@
    PostTerminalConfigurationsConfigurationResponseBody200Deleted'EnumTrue
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationResponseBody200Deleted' where
  toJSON (PostTerminalConfigurationsConfigurationResponseBody200Deleted'Other val) = val
  toJSON (PostTerminalConfigurationsConfigurationResponseBody200Deleted'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostTerminalConfigurationsConfigurationResponseBody200Deleted'EnumTrue) = Data.Aeson.Types.Internal.Bool GHC.Types.True

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationResponseBody200Deleted' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== Data.Aeson.Types.Internal.Bool GHC.Types.True -> PostTerminalConfigurationsConfigurationResponseBody200Deleted'EnumTrue
            | GHC.Base.otherwise -> PostTerminalConfigurationsConfigurationResponseBody200Deleted'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/terminal\/configurations\/{configuration}.POST.responses.200.content.application\/json.schema.anyOf.properties.object@ in the specification.
--
-- String representing the object\'s type. Objects of the same type share the same value.
data PostTerminalConfigurationsConfigurationResponseBody200Object'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostTerminalConfigurationsConfigurationResponseBody200Object'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostTerminalConfigurationsConfigurationResponseBody200Object'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"terminal.configuration"@
    PostTerminalConfigurationsConfigurationResponseBody200Object'EnumTerminal'configuration
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTerminalConfigurationsConfigurationResponseBody200Object' where
  toJSON (PostTerminalConfigurationsConfigurationResponseBody200Object'Other val) = val
  toJSON (PostTerminalConfigurationsConfigurationResponseBody200Object'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostTerminalConfigurationsConfigurationResponseBody200Object'EnumTerminal'configuration) = "terminal.configuration"

instance Data.Aeson.Types.FromJSON.FromJSON PostTerminalConfigurationsConfigurationResponseBody200Object' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "terminal.configuration" -> PostTerminalConfigurationsConfigurationResponseBody200Object'EnumTerminal'configuration
            | GHC.Base.otherwise -> PostTerminalConfigurationsConfigurationResponseBody200Object'Other val
      )
