{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema CheckoutAcssDebitMandateOptions
module StripeAPI.Types.CheckoutAcssDebitMandateOptions where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.checkout_acss_debit_mandate_options@ in the specification.
data CheckoutAcssDebitMandateOptions = CheckoutAcssDebitMandateOptions
  { -- | custom_mandate_url: A URL for custom mandate text
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    checkoutAcssDebitMandateOptionsCustomMandateUrl :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | default_for: List of Stripe products where this mandate can be selected automatically. Returned when the Session is in \`setup\` mode.
    checkoutAcssDebitMandateOptionsDefaultFor :: (GHC.Maybe.Maybe ([CheckoutAcssDebitMandateOptionsDefaultFor'])),
    -- | interval_description: Description of the interval. Only required if the \'payment_schedule\' parameter is \'interval\' or \'combined\'.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    checkoutAcssDebitMandateOptionsIntervalDescription :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | payment_schedule: Payment schedule for the mandate.
    checkoutAcssDebitMandateOptionsPaymentSchedule :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullable)),
    -- | transaction_type: Transaction type of the mandate.
    checkoutAcssDebitMandateOptionsTransactionType :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable CheckoutAcssDebitMandateOptionsTransactionType'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON CheckoutAcssDebitMandateOptions where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_mandate_url" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsCustomMandateUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_for" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsDefaultFor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_description" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsIntervalDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_schedule" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsPaymentSchedule obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction_type" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsTransactionType obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_mandate_url" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsCustomMandateUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_for" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsDefaultFor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_description" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsIntervalDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_schedule" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsPaymentSchedule obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction_type" Data.Aeson.Types.ToJSON..=)) (checkoutAcssDebitMandateOptionsTransactionType obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON CheckoutAcssDebitMandateOptions where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "CheckoutAcssDebitMandateOptions" (\obj -> ((((GHC.Base.pure CheckoutAcssDebitMandateOptions GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "custom_mandate_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "default_for")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "interval_description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_schedule")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "transaction_type"))

-- | Create a new 'CheckoutAcssDebitMandateOptions' with all required fields.
mkCheckoutAcssDebitMandateOptions :: CheckoutAcssDebitMandateOptions
mkCheckoutAcssDebitMandateOptions =
  CheckoutAcssDebitMandateOptions
    { checkoutAcssDebitMandateOptionsCustomMandateUrl = GHC.Maybe.Nothing,
      checkoutAcssDebitMandateOptionsDefaultFor = GHC.Maybe.Nothing,
      checkoutAcssDebitMandateOptionsIntervalDescription = GHC.Maybe.Nothing,
      checkoutAcssDebitMandateOptionsPaymentSchedule = GHC.Maybe.Nothing,
      checkoutAcssDebitMandateOptionsTransactionType = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.checkout_acss_debit_mandate_options.properties.default_for.items@ in the specification.
data CheckoutAcssDebitMandateOptionsDefaultFor'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    CheckoutAcssDebitMandateOptionsDefaultFor'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    CheckoutAcssDebitMandateOptionsDefaultFor'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"invoice"@
    CheckoutAcssDebitMandateOptionsDefaultFor'EnumInvoice
  | -- | Represents the JSON value @"subscription"@
    CheckoutAcssDebitMandateOptionsDefaultFor'EnumSubscription
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON CheckoutAcssDebitMandateOptionsDefaultFor' where
  toJSON (CheckoutAcssDebitMandateOptionsDefaultFor'Other val) = val
  toJSON (CheckoutAcssDebitMandateOptionsDefaultFor'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (CheckoutAcssDebitMandateOptionsDefaultFor'EnumInvoice) = "invoice"
  toJSON (CheckoutAcssDebitMandateOptionsDefaultFor'EnumSubscription) = "subscription"

instance Data.Aeson.Types.FromJSON.FromJSON CheckoutAcssDebitMandateOptionsDefaultFor' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "invoice" -> CheckoutAcssDebitMandateOptionsDefaultFor'EnumInvoice
            | val GHC.Classes.== "subscription" -> CheckoutAcssDebitMandateOptionsDefaultFor'EnumSubscription
            | GHC.Base.otherwise -> CheckoutAcssDebitMandateOptionsDefaultFor'Other val
      )

-- | Defines the enum schema located at @components.schemas.checkout_acss_debit_mandate_options.properties.payment_schedule@ in the specification.
--
-- Payment schedule for the mandate.
data CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"combined"@
    CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumCombined
  | -- | Represents the JSON value @"interval"@
    CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumInterval
  | -- | Represents the JSON value @"sporadic"@
    CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumSporadic
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullable where
  toJSON (CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableOther val) = val
  toJSON (CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumCombined) = "combined"
  toJSON (CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumInterval) = "interval"
  toJSON (CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumSporadic) = "sporadic"

instance Data.Aeson.Types.FromJSON.FromJSON CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "combined" -> CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumCombined
            | val GHC.Classes.== "interval" -> CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumInterval
            | val GHC.Classes.== "sporadic" -> CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableEnumSporadic
            | GHC.Base.otherwise -> CheckoutAcssDebitMandateOptionsPaymentSchedule'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.checkout_acss_debit_mandate_options.properties.transaction_type@ in the specification.
--
-- Transaction type of the mandate.
data CheckoutAcssDebitMandateOptionsTransactionType'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    CheckoutAcssDebitMandateOptionsTransactionType'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    CheckoutAcssDebitMandateOptionsTransactionType'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"business"@
    CheckoutAcssDebitMandateOptionsTransactionType'NonNullableEnumBusiness
  | -- | Represents the JSON value @"personal"@
    CheckoutAcssDebitMandateOptionsTransactionType'NonNullableEnumPersonal
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON CheckoutAcssDebitMandateOptionsTransactionType'NonNullable where
  toJSON (CheckoutAcssDebitMandateOptionsTransactionType'NonNullableOther val) = val
  toJSON (CheckoutAcssDebitMandateOptionsTransactionType'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (CheckoutAcssDebitMandateOptionsTransactionType'NonNullableEnumBusiness) = "business"
  toJSON (CheckoutAcssDebitMandateOptionsTransactionType'NonNullableEnumPersonal) = "personal"

instance Data.Aeson.Types.FromJSON.FromJSON CheckoutAcssDebitMandateOptionsTransactionType'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business" -> CheckoutAcssDebitMandateOptionsTransactionType'NonNullableEnumBusiness
            | val GHC.Classes.== "personal" -> CheckoutAcssDebitMandateOptionsTransactionType'NonNullableEnumPersonal
            | GHC.Base.otherwise -> CheckoutAcssDebitMandateOptionsTransactionType'NonNullableOther val
      )
