{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema IssuerFraudRecord
module StripeAPI.Types.IssuerFraudRecord where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.Charge
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuer_fraud_record@ in the specification.
--
-- This resource has been renamed to [Early Fraud
-- Warning](\#early_fraud_warning_object) and will be removed in a future API
-- version.
data IssuerFraudRecord = IssuerFraudRecord
  { -- | actionable: An IFR is actionable if it has not received a dispute and has not been fully refunded. You may wish to proactively refund a charge that receives an IFR, in order to avoid receiving a dispute later.
    issuerFraudRecordActionable :: GHC.Types.Bool,
    -- | charge: ID of the charge this issuer fraud record is for, optionally expanded.
    issuerFraudRecordCharge :: IssuerFraudRecordCharge'Variants,
    -- | created: Time at which the object was created. Measured in seconds since the Unix epoch.
    issuerFraudRecordCreated :: GHC.Types.Int,
    -- | fraud_type: The type of fraud labelled by the issuer. One of \`card_never_received\`, \`fraudulent_card_application\`, \`made_with_counterfeit_card\`, \`made_with_lost_card\`, \`made_with_stolen_card\`, \`misc\`, \`unauthorized_use_of_card\`.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuerFraudRecordFraudType :: Data.Text.Internal.Text,
    -- | has_liability_shift: If true, the associated charge is subject to [liability shift](https:\/\/stripe.com\/docs\/payments\/3d-secure\#disputed-payments).
    issuerFraudRecordHasLiabilityShift :: GHC.Types.Bool,
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuerFraudRecordId :: Data.Text.Internal.Text,
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    issuerFraudRecordLivemode :: GHC.Types.Bool,
    -- | post_date: The timestamp at which the card issuer posted the issuer fraud record.
    issuerFraudRecordPostDate :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuerFraudRecord where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["actionable" Data.Aeson.Types.ToJSON..= issuerFraudRecordActionable obj] : ["charge" Data.Aeson.Types.ToJSON..= issuerFraudRecordCharge obj] : ["created" Data.Aeson.Types.ToJSON..= issuerFraudRecordCreated obj] : ["fraud_type" Data.Aeson.Types.ToJSON..= issuerFraudRecordFraudType obj] : ["has_liability_shift" Data.Aeson.Types.ToJSON..= issuerFraudRecordHasLiabilityShift obj] : ["id" Data.Aeson.Types.ToJSON..= issuerFraudRecordId obj] : ["livemode" Data.Aeson.Types.ToJSON..= issuerFraudRecordLivemode obj] : ["post_date" Data.Aeson.Types.ToJSON..= issuerFraudRecordPostDate obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "issuer_fraud_record"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["actionable" Data.Aeson.Types.ToJSON..= issuerFraudRecordActionable obj] : ["charge" Data.Aeson.Types.ToJSON..= issuerFraudRecordCharge obj] : ["created" Data.Aeson.Types.ToJSON..= issuerFraudRecordCreated obj] : ["fraud_type" Data.Aeson.Types.ToJSON..= issuerFraudRecordFraudType obj] : ["has_liability_shift" Data.Aeson.Types.ToJSON..= issuerFraudRecordHasLiabilityShift obj] : ["id" Data.Aeson.Types.ToJSON..= issuerFraudRecordId obj] : ["livemode" Data.Aeson.Types.ToJSON..= issuerFraudRecordLivemode obj] : ["post_date" Data.Aeson.Types.ToJSON..= issuerFraudRecordPostDate obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "issuer_fraud_record"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON IssuerFraudRecord where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuerFraudRecord" (\obj -> (((((((GHC.Base.pure IssuerFraudRecord GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "actionable")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "charge")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "created")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "fraud_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "has_liability_shift")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "post_date"))

-- | Create a new 'IssuerFraudRecord' with all required fields.
mkIssuerFraudRecord ::
  -- | 'issuerFraudRecordActionable'
  GHC.Types.Bool ->
  -- | 'issuerFraudRecordCharge'
  IssuerFraudRecordCharge'Variants ->
  -- | 'issuerFraudRecordCreated'
  GHC.Types.Int ->
  -- | 'issuerFraudRecordFraudType'
  Data.Text.Internal.Text ->
  -- | 'issuerFraudRecordHasLiabilityShift'
  GHC.Types.Bool ->
  -- | 'issuerFraudRecordId'
  Data.Text.Internal.Text ->
  -- | 'issuerFraudRecordLivemode'
  GHC.Types.Bool ->
  -- | 'issuerFraudRecordPostDate'
  GHC.Types.Int ->
  IssuerFraudRecord
mkIssuerFraudRecord issuerFraudRecordActionable issuerFraudRecordCharge issuerFraudRecordCreated issuerFraudRecordFraudType issuerFraudRecordHasLiabilityShift issuerFraudRecordId issuerFraudRecordLivemode issuerFraudRecordPostDate =
  IssuerFraudRecord
    { issuerFraudRecordActionable = issuerFraudRecordActionable,
      issuerFraudRecordCharge = issuerFraudRecordCharge,
      issuerFraudRecordCreated = issuerFraudRecordCreated,
      issuerFraudRecordFraudType = issuerFraudRecordFraudType,
      issuerFraudRecordHasLiabilityShift = issuerFraudRecordHasLiabilityShift,
      issuerFraudRecordId = issuerFraudRecordId,
      issuerFraudRecordLivemode = issuerFraudRecordLivemode,
      issuerFraudRecordPostDate = issuerFraudRecordPostDate
    }

-- | Defines the oneOf schema located at @components.schemas.issuer_fraud_record.properties.charge.anyOf@ in the specification.
--
-- ID of the charge this issuer fraud record is for, optionally expanded.
data IssuerFraudRecordCharge'Variants
  = IssuerFraudRecordCharge'Text Data.Text.Internal.Text
  | IssuerFraudRecordCharge'Charge Charge
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuerFraudRecordCharge'Variants where
  toJSON (IssuerFraudRecordCharge'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (IssuerFraudRecordCharge'Charge a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON IssuerFraudRecordCharge'Variants where
  parseJSON val = case (IssuerFraudRecordCharge'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((IssuerFraudRecordCharge'Charge Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a
