{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema IssuingDisputeTreasury
module StripeAPI.Types.IssuingDisputeTreasury where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing_dispute_treasury@ in the specification.
data IssuingDisputeTreasury = IssuingDisputeTreasury
  { -- | debit_reversal: The Treasury [DebitReversal](https:\/\/stripe.com\/docs\/api\/treasury\/debit_reversals) representing this Issuing dispute
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuingDisputeTreasuryDebitReversal :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | received_debit: The Treasury [ReceivedDebit](https:\/\/stripe.com\/docs\/api\/treasury\/received_debits) that is being disputed.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuingDisputeTreasuryReceivedDebit :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingDisputeTreasury where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("debit_reversal" Data.Aeson.Types.ToJSON..=)) (issuingDisputeTreasuryDebitReversal obj) : ["received_debit" Data.Aeson.Types.ToJSON..= issuingDisputeTreasuryReceivedDebit obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("debit_reversal" Data.Aeson.Types.ToJSON..=)) (issuingDisputeTreasuryDebitReversal obj) : ["received_debit" Data.Aeson.Types.ToJSON..= issuingDisputeTreasuryReceivedDebit obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingDisputeTreasury where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingDisputeTreasury" (\obj -> (GHC.Base.pure IssuingDisputeTreasury GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "debit_reversal")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "received_debit"))

-- | Create a new 'IssuingDisputeTreasury' with all required fields.
mkIssuingDisputeTreasury ::
  -- | 'issuingDisputeTreasuryReceivedDebit'
  Data.Text.Internal.Text ->
  IssuingDisputeTreasury
mkIssuingDisputeTreasury issuingDisputeTreasuryReceivedDebit =
  IssuingDisputeTreasury
    { issuingDisputeTreasuryDebitReversal = GHC.Maybe.Nothing,
      issuingDisputeTreasuryReceivedDebit = issuingDisputeTreasuryReceivedDebit
    }
