{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentLinksResourceShippingAddressCollection
module StripeAPI.Types.PaymentLinksResourceShippingAddressCollection where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_links_resource_shipping_address_collection@ in the specification.
data PaymentLinksResourceShippingAddressCollection = PaymentLinksResourceShippingAddressCollection
  { -- | allowed_countries: An array of two-letter ISO country codes representing which countries Checkout should provide as options for shipping locations. Unsupported country codes: \`AS, CX, CC, CU, HM, IR, KP, MH, FM, NF, MP, PW, SD, SY, UM, VI\`.
    paymentLinksResourceShippingAddressCollectionAllowedCountries :: ([PaymentLinksResourceShippingAddressCollectionAllowedCountries'])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinksResourceShippingAddressCollection where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= paymentLinksResourceShippingAddressCollectionAllowedCountries obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= paymentLinksResourceShippingAddressCollectionAllowedCountries obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinksResourceShippingAddressCollection where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinksResourceShippingAddressCollection" (\obj -> GHC.Base.pure PaymentLinksResourceShippingAddressCollection GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "allowed_countries"))

-- | Create a new 'PaymentLinksResourceShippingAddressCollection' with all required fields.
mkPaymentLinksResourceShippingAddressCollection ::
  -- | 'paymentLinksResourceShippingAddressCollectionAllowedCountries'
  [PaymentLinksResourceShippingAddressCollectionAllowedCountries'] ->
  PaymentLinksResourceShippingAddressCollection
mkPaymentLinksResourceShippingAddressCollection paymentLinksResourceShippingAddressCollectionAllowedCountries = PaymentLinksResourceShippingAddressCollection {paymentLinksResourceShippingAddressCollectionAllowedCountries = paymentLinksResourceShippingAddressCollectionAllowedCountries}

-- | Defines the enum schema located at @components.schemas.payment_links_resource_shipping_address_collection.properties.allowed_countries.items@ in the specification.
data PaymentLinksResourceShippingAddressCollectionAllowedCountries'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"AC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAC
  | -- | Represents the JSON value @"AD"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAD
  | -- | Represents the JSON value @"AE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAE
  | -- | Represents the JSON value @"AF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAF
  | -- | Represents the JSON value @"AG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAG
  | -- | Represents the JSON value @"AI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAI
  | -- | Represents the JSON value @"AL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAL
  | -- | Represents the JSON value @"AM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAM
  | -- | Represents the JSON value @"AO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAO
  | -- | Represents the JSON value @"AQ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAQ
  | -- | Represents the JSON value @"AR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAR
  | -- | Represents the JSON value @"AT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAT
  | -- | Represents the JSON value @"AU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAU
  | -- | Represents the JSON value @"AW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAW
  | -- | Represents the JSON value @"AX"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAX
  | -- | Represents the JSON value @"AZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAZ
  | -- | Represents the JSON value @"BA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBA
  | -- | Represents the JSON value @"BB"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBB
  | -- | Represents the JSON value @"BD"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBD
  | -- | Represents the JSON value @"BE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBE
  | -- | Represents the JSON value @"BF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBF
  | -- | Represents the JSON value @"BG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBG
  | -- | Represents the JSON value @"BH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBH
  | -- | Represents the JSON value @"BI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBI
  | -- | Represents the JSON value @"BJ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBJ
  | -- | Represents the JSON value @"BL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBL
  | -- | Represents the JSON value @"BM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBM
  | -- | Represents the JSON value @"BN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBN
  | -- | Represents the JSON value @"BO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBO
  | -- | Represents the JSON value @"BQ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBQ
  | -- | Represents the JSON value @"BR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBR
  | -- | Represents the JSON value @"BS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBS
  | -- | Represents the JSON value @"BT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBT
  | -- | Represents the JSON value @"BV"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBV
  | -- | Represents the JSON value @"BW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBW
  | -- | Represents the JSON value @"BY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBY
  | -- | Represents the JSON value @"BZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBZ
  | -- | Represents the JSON value @"CA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCA
  | -- | Represents the JSON value @"CD"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCD
  | -- | Represents the JSON value @"CF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCF
  | -- | Represents the JSON value @"CG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCG
  | -- | Represents the JSON value @"CH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCH
  | -- | Represents the JSON value @"CI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCI
  | -- | Represents the JSON value @"CK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCK
  | -- | Represents the JSON value @"CL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCL
  | -- | Represents the JSON value @"CM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCM
  | -- | Represents the JSON value @"CN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCN
  | -- | Represents the JSON value @"CO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCO
  | -- | Represents the JSON value @"CR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCR
  | -- | Represents the JSON value @"CV"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCV
  | -- | Represents the JSON value @"CW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCW
  | -- | Represents the JSON value @"CY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCY
  | -- | Represents the JSON value @"CZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCZ
  | -- | Represents the JSON value @"DE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDE
  | -- | Represents the JSON value @"DJ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDJ
  | -- | Represents the JSON value @"DK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDK
  | -- | Represents the JSON value @"DM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDM
  | -- | Represents the JSON value @"DO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDO
  | -- | Represents the JSON value @"DZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDZ
  | -- | Represents the JSON value @"EC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEC
  | -- | Represents the JSON value @"EE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEE
  | -- | Represents the JSON value @"EG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEG
  | -- | Represents the JSON value @"EH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEH
  | -- | Represents the JSON value @"ER"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumER
  | -- | Represents the JSON value @"ES"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumES
  | -- | Represents the JSON value @"ET"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumET
  | -- | Represents the JSON value @"FI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFI
  | -- | Represents the JSON value @"FJ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFJ
  | -- | Represents the JSON value @"FK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFK
  | -- | Represents the JSON value @"FO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFO
  | -- | Represents the JSON value @"FR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFR
  | -- | Represents the JSON value @"GA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGA
  | -- | Represents the JSON value @"GB"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGB
  | -- | Represents the JSON value @"GD"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGD
  | -- | Represents the JSON value @"GE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGE
  | -- | Represents the JSON value @"GF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGF
  | -- | Represents the JSON value @"GG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGG
  | -- | Represents the JSON value @"GH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGH
  | -- | Represents the JSON value @"GI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGI
  | -- | Represents the JSON value @"GL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGL
  | -- | Represents the JSON value @"GM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGM
  | -- | Represents the JSON value @"GN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGN
  | -- | Represents the JSON value @"GP"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGP
  | -- | Represents the JSON value @"GQ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGQ
  | -- | Represents the JSON value @"GR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGR
  | -- | Represents the JSON value @"GS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGS
  | -- | Represents the JSON value @"GT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGT
  | -- | Represents the JSON value @"GU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGU
  | -- | Represents the JSON value @"GW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGW
  | -- | Represents the JSON value @"GY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGY
  | -- | Represents the JSON value @"HK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHK
  | -- | Represents the JSON value @"HN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHN
  | -- | Represents the JSON value @"HR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHR
  | -- | Represents the JSON value @"HT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHT
  | -- | Represents the JSON value @"HU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHU
  | -- | Represents the JSON value @"ID"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumID
  | -- | Represents the JSON value @"IE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIE
  | -- | Represents the JSON value @"IL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIL
  | -- | Represents the JSON value @"IM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIM
  | -- | Represents the JSON value @"IN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIN
  | -- | Represents the JSON value @"IO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIO
  | -- | Represents the JSON value @"IQ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIQ
  | -- | Represents the JSON value @"IS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIS
  | -- | Represents the JSON value @"IT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIT
  | -- | Represents the JSON value @"JE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJE
  | -- | Represents the JSON value @"JM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJM
  | -- | Represents the JSON value @"JO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJO
  | -- | Represents the JSON value @"JP"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJP
  | -- | Represents the JSON value @"KE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKE
  | -- | Represents the JSON value @"KG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKG
  | -- | Represents the JSON value @"KH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKH
  | -- | Represents the JSON value @"KI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKI
  | -- | Represents the JSON value @"KM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKM
  | -- | Represents the JSON value @"KN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKN
  | -- | Represents the JSON value @"KR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKR
  | -- | Represents the JSON value @"KW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKW
  | -- | Represents the JSON value @"KY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKY
  | -- | Represents the JSON value @"KZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKZ
  | -- | Represents the JSON value @"LA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLA
  | -- | Represents the JSON value @"LB"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLB
  | -- | Represents the JSON value @"LC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLC
  | -- | Represents the JSON value @"LI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLI
  | -- | Represents the JSON value @"LK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLK
  | -- | Represents the JSON value @"LR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLR
  | -- | Represents the JSON value @"LS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLS
  | -- | Represents the JSON value @"LT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLT
  | -- | Represents the JSON value @"LU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLU
  | -- | Represents the JSON value @"LV"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLV
  | -- | Represents the JSON value @"LY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLY
  | -- | Represents the JSON value @"MA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMA
  | -- | Represents the JSON value @"MC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMC
  | -- | Represents the JSON value @"MD"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMD
  | -- | Represents the JSON value @"ME"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumME
  | -- | Represents the JSON value @"MF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMF
  | -- | Represents the JSON value @"MG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMG
  | -- | Represents the JSON value @"MK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMK
  | -- | Represents the JSON value @"ML"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumML
  | -- | Represents the JSON value @"MM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMM
  | -- | Represents the JSON value @"MN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMN
  | -- | Represents the JSON value @"MO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMO
  | -- | Represents the JSON value @"MQ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMQ
  | -- | Represents the JSON value @"MR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMR
  | -- | Represents the JSON value @"MS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMS
  | -- | Represents the JSON value @"MT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMT
  | -- | Represents the JSON value @"MU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMU
  | -- | Represents the JSON value @"MV"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMV
  | -- | Represents the JSON value @"MW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMW
  | -- | Represents the JSON value @"MX"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMX
  | -- | Represents the JSON value @"MY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMY
  | -- | Represents the JSON value @"MZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMZ
  | -- | Represents the JSON value @"NA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNA
  | -- | Represents the JSON value @"NC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNC
  | -- | Represents the JSON value @"NE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNE
  | -- | Represents the JSON value @"NG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNG
  | -- | Represents the JSON value @"NI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNI
  | -- | Represents the JSON value @"NL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNL
  | -- | Represents the JSON value @"NO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNO
  | -- | Represents the JSON value @"NP"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNP
  | -- | Represents the JSON value @"NR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNR
  | -- | Represents the JSON value @"NU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNU
  | -- | Represents the JSON value @"NZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNZ
  | -- | Represents the JSON value @"OM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumOM
  | -- | Represents the JSON value @"PA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPA
  | -- | Represents the JSON value @"PE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPE
  | -- | Represents the JSON value @"PF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPF
  | -- | Represents the JSON value @"PG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPG
  | -- | Represents the JSON value @"PH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPH
  | -- | Represents the JSON value @"PK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPK
  | -- | Represents the JSON value @"PL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPL
  | -- | Represents the JSON value @"PM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPM
  | -- | Represents the JSON value @"PN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPN
  | -- | Represents the JSON value @"PR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPR
  | -- | Represents the JSON value @"PS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPS
  | -- | Represents the JSON value @"PT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPT
  | -- | Represents the JSON value @"PY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPY
  | -- | Represents the JSON value @"QA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumQA
  | -- | Represents the JSON value @"RE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRE
  | -- | Represents the JSON value @"RO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRO
  | -- | Represents the JSON value @"RS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRS
  | -- | Represents the JSON value @"RU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRU
  | -- | Represents the JSON value @"RW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRW
  | -- | Represents the JSON value @"SA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSA
  | -- | Represents the JSON value @"SB"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSB
  | -- | Represents the JSON value @"SC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSC
  | -- | Represents the JSON value @"SE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSE
  | -- | Represents the JSON value @"SG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSG
  | -- | Represents the JSON value @"SH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSH
  | -- | Represents the JSON value @"SI"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSI
  | -- | Represents the JSON value @"SJ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSJ
  | -- | Represents the JSON value @"SK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSK
  | -- | Represents the JSON value @"SL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSL
  | -- | Represents the JSON value @"SM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSM
  | -- | Represents the JSON value @"SN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSN
  | -- | Represents the JSON value @"SO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSO
  | -- | Represents the JSON value @"SR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSR
  | -- | Represents the JSON value @"SS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSS
  | -- | Represents the JSON value @"ST"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumST
  | -- | Represents the JSON value @"SV"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSV
  | -- | Represents the JSON value @"SX"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSX
  | -- | Represents the JSON value @"SZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSZ
  | -- | Represents the JSON value @"TA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTA
  | -- | Represents the JSON value @"TC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTC
  | -- | Represents the JSON value @"TD"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTD
  | -- | Represents the JSON value @"TF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTF
  | -- | Represents the JSON value @"TG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTG
  | -- | Represents the JSON value @"TH"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTH
  | -- | Represents the JSON value @"TJ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTJ
  | -- | Represents the JSON value @"TK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTK
  | -- | Represents the JSON value @"TL"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTL
  | -- | Represents the JSON value @"TM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTM
  | -- | Represents the JSON value @"TN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTN
  | -- | Represents the JSON value @"TO"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTO
  | -- | Represents the JSON value @"TR"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTR
  | -- | Represents the JSON value @"TT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTT
  | -- | Represents the JSON value @"TV"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTV
  | -- | Represents the JSON value @"TW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTW
  | -- | Represents the JSON value @"TZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTZ
  | -- | Represents the JSON value @"UA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUA
  | -- | Represents the JSON value @"UG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUG
  | -- | Represents the JSON value @"US"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUS
  | -- | Represents the JSON value @"UY"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUY
  | -- | Represents the JSON value @"UZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUZ
  | -- | Represents the JSON value @"VA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVA
  | -- | Represents the JSON value @"VC"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVC
  | -- | Represents the JSON value @"VE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVE
  | -- | Represents the JSON value @"VG"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVG
  | -- | Represents the JSON value @"VN"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVN
  | -- | Represents the JSON value @"VU"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVU
  | -- | Represents the JSON value @"WF"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumWF
  | -- | Represents the JSON value @"WS"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumWS
  | -- | Represents the JSON value @"XK"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumXK
  | -- | Represents the JSON value @"YE"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumYE
  | -- | Represents the JSON value @"YT"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumYT
  | -- | Represents the JSON value @"ZA"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZA
  | -- | Represents the JSON value @"ZM"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZM
  | -- | Represents the JSON value @"ZW"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZW
  | -- | Represents the JSON value @"ZZ"@
    PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZZ
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinksResourceShippingAddressCollectionAllowedCountries' where
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'Other val) = val
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAC) = "AC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAD) = "AD"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAE) = "AE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAF) = "AF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAG) = "AG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAI) = "AI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAL) = "AL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAM) = "AM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAO) = "AO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAQ) = "AQ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAR) = "AR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAT) = "AT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAU) = "AU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAW) = "AW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAX) = "AX"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAZ) = "AZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBA) = "BA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBB) = "BB"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBD) = "BD"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBE) = "BE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBF) = "BF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBG) = "BG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBH) = "BH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBI) = "BI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBJ) = "BJ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBL) = "BL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBM) = "BM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBN) = "BN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBO) = "BO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBQ) = "BQ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBR) = "BR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBS) = "BS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBT) = "BT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBV) = "BV"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBW) = "BW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBY) = "BY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBZ) = "BZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCA) = "CA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCD) = "CD"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCF) = "CF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCG) = "CG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCH) = "CH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCI) = "CI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCK) = "CK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCL) = "CL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCM) = "CM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCN) = "CN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCO) = "CO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCR) = "CR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCV) = "CV"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCW) = "CW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCY) = "CY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCZ) = "CZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDE) = "DE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDJ) = "DJ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDK) = "DK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDM) = "DM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDO) = "DO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDZ) = "DZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEC) = "EC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEE) = "EE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEG) = "EG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEH) = "EH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumER) = "ER"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumES) = "ES"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumET) = "ET"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFI) = "FI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFJ) = "FJ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFK) = "FK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFO) = "FO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFR) = "FR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGA) = "GA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGB) = "GB"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGD) = "GD"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGE) = "GE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGF) = "GF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGG) = "GG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGH) = "GH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGI) = "GI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGL) = "GL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGM) = "GM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGN) = "GN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGP) = "GP"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGQ) = "GQ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGR) = "GR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGS) = "GS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGT) = "GT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGU) = "GU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGW) = "GW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGY) = "GY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHK) = "HK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHN) = "HN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHR) = "HR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHT) = "HT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHU) = "HU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumID) = "ID"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIE) = "IE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIL) = "IL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIM) = "IM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIN) = "IN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIO) = "IO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIQ) = "IQ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIS) = "IS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIT) = "IT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJE) = "JE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJM) = "JM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJO) = "JO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJP) = "JP"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKE) = "KE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKG) = "KG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKH) = "KH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKI) = "KI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKM) = "KM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKN) = "KN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKR) = "KR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKW) = "KW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKY) = "KY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKZ) = "KZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLA) = "LA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLB) = "LB"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLC) = "LC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLI) = "LI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLK) = "LK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLR) = "LR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLS) = "LS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLT) = "LT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLU) = "LU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLV) = "LV"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLY) = "LY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMA) = "MA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMC) = "MC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMD) = "MD"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumME) = "ME"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMF) = "MF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMG) = "MG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMK) = "MK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumML) = "ML"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMM) = "MM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMN) = "MN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMO) = "MO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMQ) = "MQ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMR) = "MR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMS) = "MS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMT) = "MT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMU) = "MU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMV) = "MV"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMW) = "MW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMX) = "MX"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMY) = "MY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMZ) = "MZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNA) = "NA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNC) = "NC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNE) = "NE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNG) = "NG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNI) = "NI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNL) = "NL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNO) = "NO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNP) = "NP"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNR) = "NR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNU) = "NU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNZ) = "NZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumOM) = "OM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPA) = "PA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPE) = "PE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPF) = "PF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPG) = "PG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPH) = "PH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPK) = "PK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPL) = "PL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPM) = "PM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPN) = "PN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPR) = "PR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPS) = "PS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPT) = "PT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPY) = "PY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumQA) = "QA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRE) = "RE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRO) = "RO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRS) = "RS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRU) = "RU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRW) = "RW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSA) = "SA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSB) = "SB"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSC) = "SC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSE) = "SE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSG) = "SG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSH) = "SH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSI) = "SI"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSJ) = "SJ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSK) = "SK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSL) = "SL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSM) = "SM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSN) = "SN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSO) = "SO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSR) = "SR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSS) = "SS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumST) = "ST"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSV) = "SV"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSX) = "SX"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSZ) = "SZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTA) = "TA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTC) = "TC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTD) = "TD"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTF) = "TF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTG) = "TG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTH) = "TH"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTJ) = "TJ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTK) = "TK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTL) = "TL"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTM) = "TM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTN) = "TN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTO) = "TO"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTR) = "TR"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTT) = "TT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTV) = "TV"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTW) = "TW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTZ) = "TZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUA) = "UA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUG) = "UG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUS) = "US"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUY) = "UY"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUZ) = "UZ"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVA) = "VA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVC) = "VC"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVE) = "VE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVG) = "VG"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVN) = "VN"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVU) = "VU"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumWF) = "WF"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumWS) = "WS"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumXK) = "XK"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumYE) = "YE"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumYT) = "YT"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZA) = "ZA"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZM) = "ZM"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZW) = "ZW"
  toJSON (PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZZ) = "ZZ"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinksResourceShippingAddressCollectionAllowedCountries' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "AC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAC
            | val GHC.Classes.== "AD" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAD
            | val GHC.Classes.== "AE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAE
            | val GHC.Classes.== "AF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAF
            | val GHC.Classes.== "AG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAG
            | val GHC.Classes.== "AI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAI
            | val GHC.Classes.== "AL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAL
            | val GHC.Classes.== "AM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAM
            | val GHC.Classes.== "AO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAO
            | val GHC.Classes.== "AQ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAQ
            | val GHC.Classes.== "AR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAR
            | val GHC.Classes.== "AT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAT
            | val GHC.Classes.== "AU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAU
            | val GHC.Classes.== "AW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAW
            | val GHC.Classes.== "AX" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAX
            | val GHC.Classes.== "AZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumAZ
            | val GHC.Classes.== "BA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBA
            | val GHC.Classes.== "BB" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBB
            | val GHC.Classes.== "BD" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBD
            | val GHC.Classes.== "BE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBE
            | val GHC.Classes.== "BF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBF
            | val GHC.Classes.== "BG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBG
            | val GHC.Classes.== "BH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBH
            | val GHC.Classes.== "BI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBI
            | val GHC.Classes.== "BJ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBJ
            | val GHC.Classes.== "BL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBL
            | val GHC.Classes.== "BM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBM
            | val GHC.Classes.== "BN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBN
            | val GHC.Classes.== "BO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBO
            | val GHC.Classes.== "BQ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBQ
            | val GHC.Classes.== "BR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBR
            | val GHC.Classes.== "BS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBS
            | val GHC.Classes.== "BT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBT
            | val GHC.Classes.== "BV" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBV
            | val GHC.Classes.== "BW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBW
            | val GHC.Classes.== "BY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBY
            | val GHC.Classes.== "BZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumBZ
            | val GHC.Classes.== "CA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCA
            | val GHC.Classes.== "CD" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCD
            | val GHC.Classes.== "CF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCF
            | val GHC.Classes.== "CG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCG
            | val GHC.Classes.== "CH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCH
            | val GHC.Classes.== "CI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCI
            | val GHC.Classes.== "CK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCK
            | val GHC.Classes.== "CL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCL
            | val GHC.Classes.== "CM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCM
            | val GHC.Classes.== "CN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCN
            | val GHC.Classes.== "CO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCO
            | val GHC.Classes.== "CR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCR
            | val GHC.Classes.== "CV" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCV
            | val GHC.Classes.== "CW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCW
            | val GHC.Classes.== "CY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCY
            | val GHC.Classes.== "CZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumCZ
            | val GHC.Classes.== "DE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDE
            | val GHC.Classes.== "DJ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDJ
            | val GHC.Classes.== "DK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDK
            | val GHC.Classes.== "DM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDM
            | val GHC.Classes.== "DO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDO
            | val GHC.Classes.== "DZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumDZ
            | val GHC.Classes.== "EC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEC
            | val GHC.Classes.== "EE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEE
            | val GHC.Classes.== "EG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEG
            | val GHC.Classes.== "EH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumEH
            | val GHC.Classes.== "ER" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumER
            | val GHC.Classes.== "ES" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumES
            | val GHC.Classes.== "ET" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumET
            | val GHC.Classes.== "FI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFI
            | val GHC.Classes.== "FJ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFJ
            | val GHC.Classes.== "FK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFK
            | val GHC.Classes.== "FO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFO
            | val GHC.Classes.== "FR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumFR
            | val GHC.Classes.== "GA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGA
            | val GHC.Classes.== "GB" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGB
            | val GHC.Classes.== "GD" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGD
            | val GHC.Classes.== "GE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGE
            | val GHC.Classes.== "GF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGF
            | val GHC.Classes.== "GG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGG
            | val GHC.Classes.== "GH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGH
            | val GHC.Classes.== "GI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGI
            | val GHC.Classes.== "GL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGL
            | val GHC.Classes.== "GM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGM
            | val GHC.Classes.== "GN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGN
            | val GHC.Classes.== "GP" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGP
            | val GHC.Classes.== "GQ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGQ
            | val GHC.Classes.== "GR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGR
            | val GHC.Classes.== "GS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGS
            | val GHC.Classes.== "GT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGT
            | val GHC.Classes.== "GU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGU
            | val GHC.Classes.== "GW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGW
            | val GHC.Classes.== "GY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumGY
            | val GHC.Classes.== "HK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHK
            | val GHC.Classes.== "HN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHN
            | val GHC.Classes.== "HR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHR
            | val GHC.Classes.== "HT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHT
            | val GHC.Classes.== "HU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumHU
            | val GHC.Classes.== "ID" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumID
            | val GHC.Classes.== "IE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIE
            | val GHC.Classes.== "IL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIL
            | val GHC.Classes.== "IM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIM
            | val GHC.Classes.== "IN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIN
            | val GHC.Classes.== "IO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIO
            | val GHC.Classes.== "IQ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIQ
            | val GHC.Classes.== "IS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIS
            | val GHC.Classes.== "IT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumIT
            | val GHC.Classes.== "JE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJE
            | val GHC.Classes.== "JM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJM
            | val GHC.Classes.== "JO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJO
            | val GHC.Classes.== "JP" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumJP
            | val GHC.Classes.== "KE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKE
            | val GHC.Classes.== "KG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKG
            | val GHC.Classes.== "KH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKH
            | val GHC.Classes.== "KI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKI
            | val GHC.Classes.== "KM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKM
            | val GHC.Classes.== "KN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKN
            | val GHC.Classes.== "KR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKR
            | val GHC.Classes.== "KW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKW
            | val GHC.Classes.== "KY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKY
            | val GHC.Classes.== "KZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumKZ
            | val GHC.Classes.== "LA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLA
            | val GHC.Classes.== "LB" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLB
            | val GHC.Classes.== "LC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLC
            | val GHC.Classes.== "LI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLI
            | val GHC.Classes.== "LK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLK
            | val GHC.Classes.== "LR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLR
            | val GHC.Classes.== "LS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLS
            | val GHC.Classes.== "LT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLT
            | val GHC.Classes.== "LU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLU
            | val GHC.Classes.== "LV" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLV
            | val GHC.Classes.== "LY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumLY
            | val GHC.Classes.== "MA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMA
            | val GHC.Classes.== "MC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMC
            | val GHC.Classes.== "MD" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMD
            | val GHC.Classes.== "ME" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumME
            | val GHC.Classes.== "MF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMF
            | val GHC.Classes.== "MG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMG
            | val GHC.Classes.== "MK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMK
            | val GHC.Classes.== "ML" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumML
            | val GHC.Classes.== "MM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMM
            | val GHC.Classes.== "MN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMN
            | val GHC.Classes.== "MO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMO
            | val GHC.Classes.== "MQ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMQ
            | val GHC.Classes.== "MR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMR
            | val GHC.Classes.== "MS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMS
            | val GHC.Classes.== "MT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMT
            | val GHC.Classes.== "MU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMU
            | val GHC.Classes.== "MV" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMV
            | val GHC.Classes.== "MW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMW
            | val GHC.Classes.== "MX" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMX
            | val GHC.Classes.== "MY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMY
            | val GHC.Classes.== "MZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumMZ
            | val GHC.Classes.== "NA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNA
            | val GHC.Classes.== "NC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNC
            | val GHC.Classes.== "NE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNE
            | val GHC.Classes.== "NG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNG
            | val GHC.Classes.== "NI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNI
            | val GHC.Classes.== "NL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNL
            | val GHC.Classes.== "NO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNO
            | val GHC.Classes.== "NP" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNP
            | val GHC.Classes.== "NR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNR
            | val GHC.Classes.== "NU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNU
            | val GHC.Classes.== "NZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumNZ
            | val GHC.Classes.== "OM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumOM
            | val GHC.Classes.== "PA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPA
            | val GHC.Classes.== "PE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPE
            | val GHC.Classes.== "PF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPF
            | val GHC.Classes.== "PG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPG
            | val GHC.Classes.== "PH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPH
            | val GHC.Classes.== "PK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPK
            | val GHC.Classes.== "PL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPL
            | val GHC.Classes.== "PM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPM
            | val GHC.Classes.== "PN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPN
            | val GHC.Classes.== "PR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPR
            | val GHC.Classes.== "PS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPS
            | val GHC.Classes.== "PT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPT
            | val GHC.Classes.== "PY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumPY
            | val GHC.Classes.== "QA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumQA
            | val GHC.Classes.== "RE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRE
            | val GHC.Classes.== "RO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRO
            | val GHC.Classes.== "RS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRS
            | val GHC.Classes.== "RU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRU
            | val GHC.Classes.== "RW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumRW
            | val GHC.Classes.== "SA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSA
            | val GHC.Classes.== "SB" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSB
            | val GHC.Classes.== "SC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSC
            | val GHC.Classes.== "SE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSE
            | val GHC.Classes.== "SG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSG
            | val GHC.Classes.== "SH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSH
            | val GHC.Classes.== "SI" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSI
            | val GHC.Classes.== "SJ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSJ
            | val GHC.Classes.== "SK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSK
            | val GHC.Classes.== "SL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSL
            | val GHC.Classes.== "SM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSM
            | val GHC.Classes.== "SN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSN
            | val GHC.Classes.== "SO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSO
            | val GHC.Classes.== "SR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSR
            | val GHC.Classes.== "SS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSS
            | val GHC.Classes.== "ST" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumST
            | val GHC.Classes.== "SV" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSV
            | val GHC.Classes.== "SX" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSX
            | val GHC.Classes.== "SZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumSZ
            | val GHC.Classes.== "TA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTA
            | val GHC.Classes.== "TC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTC
            | val GHC.Classes.== "TD" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTD
            | val GHC.Classes.== "TF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTF
            | val GHC.Classes.== "TG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTG
            | val GHC.Classes.== "TH" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTH
            | val GHC.Classes.== "TJ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTJ
            | val GHC.Classes.== "TK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTK
            | val GHC.Classes.== "TL" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTL
            | val GHC.Classes.== "TM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTM
            | val GHC.Classes.== "TN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTN
            | val GHC.Classes.== "TO" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTO
            | val GHC.Classes.== "TR" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTR
            | val GHC.Classes.== "TT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTT
            | val GHC.Classes.== "TV" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTV
            | val GHC.Classes.== "TW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTW
            | val GHC.Classes.== "TZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumTZ
            | val GHC.Classes.== "UA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUA
            | val GHC.Classes.== "UG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUG
            | val GHC.Classes.== "US" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUS
            | val GHC.Classes.== "UY" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUY
            | val GHC.Classes.== "UZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumUZ
            | val GHC.Classes.== "VA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVA
            | val GHC.Classes.== "VC" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVC
            | val GHC.Classes.== "VE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVE
            | val GHC.Classes.== "VG" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVG
            | val GHC.Classes.== "VN" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVN
            | val GHC.Classes.== "VU" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumVU
            | val GHC.Classes.== "WF" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumWF
            | val GHC.Classes.== "WS" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumWS
            | val GHC.Classes.== "XK" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumXK
            | val GHC.Classes.== "YE" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumYE
            | val GHC.Classes.== "YT" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumYT
            | val GHC.Classes.== "ZA" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZA
            | val GHC.Classes.== "ZM" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZM
            | val GHC.Classes.== "ZW" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZW
            | val GHC.Classes.== "ZZ" -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'EnumZZ
            | GHC.Base.otherwise -> PaymentLinksResourceShippingAddressCollectionAllowedCountries'Other val
      )
