{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentMethodOptionsCustomerBalanceBankTransfer
module StripeAPI.Types.PaymentMethodOptionsCustomerBalanceBankTransfer where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.PaymentMethodOptionsCustomerBalanceEuBankAccount
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_method_options_customer_balance_bank_transfer@ in the specification.
data PaymentMethodOptionsCustomerBalanceBankTransfer = PaymentMethodOptionsCustomerBalanceBankTransfer
  { -- | eu_bank_transfer:
    paymentMethodOptionsCustomerBalanceBankTransferEuBankTransfer :: (GHC.Maybe.Maybe PaymentMethodOptionsCustomerBalanceEuBankAccount),
    -- | requested_address_types: List of address types that should be returned in the financial_addresses response. If not specified, all valid types will be returned.
    --
    -- Permitted values include: \`sort_code\`, \`zengin\`, \`iban\`, or \`spei\`.
    paymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes :: (GHC.Maybe.Maybe ([PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'])),
    -- | type: The bank transfer type that this PaymentIntent is allowed to use for funding Permitted values include: \`eu_bank_transfer\`, \`gb_bank_transfer\`, \`jp_bank_transfer\`, or \`mx_bank_transfer\`.
    paymentMethodOptionsCustomerBalanceBankTransferType :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodOptionsCustomerBalanceBankTransfer where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eu_bank_transfer" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsCustomerBalanceBankTransferEuBankTransfer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("requested_address_types" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsCustomerBalanceBankTransferType obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eu_bank_transfer" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsCustomerBalanceBankTransferEuBankTransfer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("requested_address_types" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsCustomerBalanceBankTransferType obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodOptionsCustomerBalanceBankTransfer where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentMethodOptionsCustomerBalanceBankTransfer" (\obj -> ((GHC.Base.pure PaymentMethodOptionsCustomerBalanceBankTransfer GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "eu_bank_transfer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "requested_address_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "type"))

-- | Create a new 'PaymentMethodOptionsCustomerBalanceBankTransfer' with all required fields.
mkPaymentMethodOptionsCustomerBalanceBankTransfer :: PaymentMethodOptionsCustomerBalanceBankTransfer
mkPaymentMethodOptionsCustomerBalanceBankTransfer =
  PaymentMethodOptionsCustomerBalanceBankTransfer
    { paymentMethodOptionsCustomerBalanceBankTransferEuBankTransfer = GHC.Maybe.Nothing,
      paymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes = GHC.Maybe.Nothing,
      paymentMethodOptionsCustomerBalanceBankTransferType = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_method_options_customer_balance_bank_transfer.properties.requested_address_types.items@ in the specification.
data PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"iban"@
    PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumIban
  | -- | Represents the JSON value @"sepa"@
    PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSepa
  | -- | Represents the JSON value @"sort_code"@
    PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSortCode
  | -- | Represents the JSON value @"spei"@
    PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSpei
  | -- | Represents the JSON value @"zengin"@
    PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumZengin
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes' where
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'Other val) = val
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumIban) = "iban"
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSepa) = "sepa"
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSortCode) = "sort_code"
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSpei) = "spei"
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumZengin) = "zengin"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "iban" -> PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumIban
            | val GHC.Classes.== "sepa" -> PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSepa
            | val GHC.Classes.== "sort_code" -> PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSortCode
            | val GHC.Classes.== "spei" -> PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumSpei
            | val GHC.Classes.== "zengin" -> PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'EnumZengin
            | GHC.Base.otherwise -> PaymentMethodOptionsCustomerBalanceBankTransferRequestedAddressTypes'Other val
      )

-- | Defines the enum schema located at @components.schemas.payment_method_options_customer_balance_bank_transfer.properties.type@ in the specification.
--
-- The bank transfer type that this PaymentIntent is allowed to use for funding Permitted values include: \`eu_bank_transfer\`, \`gb_bank_transfer\`, \`jp_bank_transfer\`, or \`mx_bank_transfer\`.
data PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"eu_bank_transfer"@
    PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumEuBankTransfer
  | -- | Represents the JSON value @"gb_bank_transfer"@
    PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumGbBankTransfer
  | -- | Represents the JSON value @"jp_bank_transfer"@
    PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumJpBankTransfer
  | -- | Represents the JSON value @"mx_bank_transfer"@
    PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumMxBankTransfer
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullable where
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableOther val) = val
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumEuBankTransfer) = "eu_bank_transfer"
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumGbBankTransfer) = "gb_bank_transfer"
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumJpBankTransfer) = "jp_bank_transfer"
  toJSON (PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumMxBankTransfer) = "mx_bank_transfer"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "eu_bank_transfer" -> PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumEuBankTransfer
            | val GHC.Classes.== "gb_bank_transfer" -> PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumGbBankTransfer
            | val GHC.Classes.== "jp_bank_transfer" -> PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumJpBankTransfer
            | val GHC.Classes.== "mx_bank_transfer" -> PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableEnumMxBankTransfer
            | GHC.Base.otherwise -> PaymentMethodOptionsCustomerBalanceBankTransferType'NonNullableOther val
      )
