{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema Treasury_CreditReversal
module StripeAPI.Types.Treasury_CreditReversal where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.ReceivedCreditsResourceStatusTransitions
import {-# SOURCE #-} StripeAPI.Types.Treasury_Transaction
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.treasury.credit_reversal@ in the specification.
--
-- You can reverse some [ReceivedCredits](https:\/\/stripe.com\/docs\/api\#received_credits) depending on their network and source flow. Reversing a ReceivedCredit leads to the creation of a new object known as a CreditReversal.
data Treasury'creditReversal = Treasury'creditReversal
  { -- | amount: Amount (in cents) transferred.
    treasury'creditReversalAmount :: GHC.Types.Int,
    -- | currency: Three-letter [ISO currency code](https:\/\/www.iso.org\/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https:\/\/stripe.com\/docs\/currencies).
    treasury'creditReversalCurrency :: Data.Text.Internal.Text,
    -- | financial_account: The FinancialAccount to reverse funds from.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    treasury'creditReversalFinancialAccount :: Data.Text.Internal.Text,
    -- | hosted_regulatory_receipt_url: A [hosted transaction receipt](https:\/\/stripe.com\/docs\/treasury\/moving-money\/regulatory-receipts) URL that is provided when money movement is considered regulated under Stripe\'s money transmission licenses.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    treasury'creditReversalHostedRegulatoryReceiptUrl :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    treasury'creditReversalId :: Data.Text.Internal.Text,
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    treasury'creditReversalLivemode :: GHC.Types.Bool,
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
    treasury'creditReversalMetadata :: Data.Aeson.Types.Internal.Object,
    -- | network: The rails used to reverse the funds.
    treasury'creditReversalNetwork :: Treasury'creditReversalNetwork',
    -- | received_credit: The ReceivedCredit being reversed.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    treasury'creditReversalReceivedCredit :: Data.Text.Internal.Text,
    -- | status: Status of the CreditReversal
    treasury'creditReversalStatus :: Treasury'creditReversalStatus',
    -- | status_transitions:
    treasury'creditReversalStatusTransitions :: ReceivedCreditsResourceStatusTransitions,
    -- | transaction: The Transaction associated with this object.
    treasury'creditReversalTransaction :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Treasury'creditReversalTransaction'NonNullableVariants))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Treasury'creditReversal where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= treasury'creditReversalAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= treasury'creditReversalCurrency obj] : ["financial_account" Data.Aeson.Types.ToJSON..= treasury'creditReversalFinancialAccount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hosted_regulatory_receipt_url" Data.Aeson.Types.ToJSON..=)) (treasury'creditReversalHostedRegulatoryReceiptUrl obj) : ["id" Data.Aeson.Types.ToJSON..= treasury'creditReversalId obj] : ["livemode" Data.Aeson.Types.ToJSON..= treasury'creditReversalLivemode obj] : ["metadata" Data.Aeson.Types.ToJSON..= treasury'creditReversalMetadata obj] : ["network" Data.Aeson.Types.ToJSON..= treasury'creditReversalNetwork obj] : ["received_credit" Data.Aeson.Types.ToJSON..= treasury'creditReversalReceivedCredit obj] : ["status" Data.Aeson.Types.ToJSON..= treasury'creditReversalStatus obj] : ["status_transitions" Data.Aeson.Types.ToJSON..= treasury'creditReversalStatusTransitions obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction" Data.Aeson.Types.ToJSON..=)) (treasury'creditReversalTransaction obj) : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "treasury.credit_reversal"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= treasury'creditReversalAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= treasury'creditReversalCurrency obj] : ["financial_account" Data.Aeson.Types.ToJSON..= treasury'creditReversalFinancialAccount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hosted_regulatory_receipt_url" Data.Aeson.Types.ToJSON..=)) (treasury'creditReversalHostedRegulatoryReceiptUrl obj) : ["id" Data.Aeson.Types.ToJSON..= treasury'creditReversalId obj] : ["livemode" Data.Aeson.Types.ToJSON..= treasury'creditReversalLivemode obj] : ["metadata" Data.Aeson.Types.ToJSON..= treasury'creditReversalMetadata obj] : ["network" Data.Aeson.Types.ToJSON..= treasury'creditReversalNetwork obj] : ["received_credit" Data.Aeson.Types.ToJSON..= treasury'creditReversalReceivedCredit obj] : ["status" Data.Aeson.Types.ToJSON..= treasury'creditReversalStatus obj] : ["status_transitions" Data.Aeson.Types.ToJSON..= treasury'creditReversalStatusTransitions obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction" Data.Aeson.Types.ToJSON..=)) (treasury'creditReversalTransaction obj) : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "treasury.credit_reversal"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Treasury'creditReversal where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Treasury'creditReversal" (\obj -> (((((((((((GHC.Base.pure Treasury'creditReversal GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "financial_account")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "hosted_regulatory_receipt_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "network")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "received_credit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "status")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "status_transitions")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "transaction"))

-- | Create a new 'Treasury'creditReversal' with all required fields.
mkTreasury'creditReversal ::
  -- | 'treasury'creditReversalAmount'
  GHC.Types.Int ->
  -- | 'treasury'creditReversalCurrency'
  Data.Text.Internal.Text ->
  -- | 'treasury'creditReversalFinancialAccount'
  Data.Text.Internal.Text ->
  -- | 'treasury'creditReversalId'
  Data.Text.Internal.Text ->
  -- | 'treasury'creditReversalLivemode'
  GHC.Types.Bool ->
  -- | 'treasury'creditReversalMetadata'
  Data.Aeson.Types.Internal.Object ->
  -- | 'treasury'creditReversalNetwork'
  Treasury'creditReversalNetwork' ->
  -- | 'treasury'creditReversalReceivedCredit'
  Data.Text.Internal.Text ->
  -- | 'treasury'creditReversalStatus'
  Treasury'creditReversalStatus' ->
  -- | 'treasury'creditReversalStatusTransitions'
  ReceivedCreditsResourceStatusTransitions ->
  Treasury'creditReversal
mkTreasury'creditReversal treasury'creditReversalAmount treasury'creditReversalCurrency treasury'creditReversalFinancialAccount treasury'creditReversalId treasury'creditReversalLivemode treasury'creditReversalMetadata treasury'creditReversalNetwork treasury'creditReversalReceivedCredit treasury'creditReversalStatus treasury'creditReversalStatusTransitions =
  Treasury'creditReversal
    { treasury'creditReversalAmount = treasury'creditReversalAmount,
      treasury'creditReversalCurrency = treasury'creditReversalCurrency,
      treasury'creditReversalFinancialAccount = treasury'creditReversalFinancialAccount,
      treasury'creditReversalHostedRegulatoryReceiptUrl = GHC.Maybe.Nothing,
      treasury'creditReversalId = treasury'creditReversalId,
      treasury'creditReversalLivemode = treasury'creditReversalLivemode,
      treasury'creditReversalMetadata = treasury'creditReversalMetadata,
      treasury'creditReversalNetwork = treasury'creditReversalNetwork,
      treasury'creditReversalReceivedCredit = treasury'creditReversalReceivedCredit,
      treasury'creditReversalStatus = treasury'creditReversalStatus,
      treasury'creditReversalStatusTransitions = treasury'creditReversalStatusTransitions,
      treasury'creditReversalTransaction = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.treasury.credit_reversal.properties.network@ in the specification.
--
-- The rails used to reverse the funds.
data Treasury'creditReversalNetwork'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Treasury'creditReversalNetwork'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Treasury'creditReversalNetwork'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ach"@
    Treasury'creditReversalNetwork'EnumAch
  | -- | Represents the JSON value @"stripe"@
    Treasury'creditReversalNetwork'EnumStripe
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Treasury'creditReversalNetwork' where
  toJSON (Treasury'creditReversalNetwork'Other val) = val
  toJSON (Treasury'creditReversalNetwork'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Treasury'creditReversalNetwork'EnumAch) = "ach"
  toJSON (Treasury'creditReversalNetwork'EnumStripe) = "stripe"

instance Data.Aeson.Types.FromJSON.FromJSON Treasury'creditReversalNetwork' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ach" -> Treasury'creditReversalNetwork'EnumAch
            | val GHC.Classes.== "stripe" -> Treasury'creditReversalNetwork'EnumStripe
            | GHC.Base.otherwise -> Treasury'creditReversalNetwork'Other val
      )

-- | Defines the enum schema located at @components.schemas.treasury.credit_reversal.properties.status@ in the specification.
--
-- Status of the CreditReversal
data Treasury'creditReversalStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Treasury'creditReversalStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Treasury'creditReversalStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"canceled"@
    Treasury'creditReversalStatus'EnumCanceled
  | -- | Represents the JSON value @"posted"@
    Treasury'creditReversalStatus'EnumPosted
  | -- | Represents the JSON value @"processing"@
    Treasury'creditReversalStatus'EnumProcessing
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Treasury'creditReversalStatus' where
  toJSON (Treasury'creditReversalStatus'Other val) = val
  toJSON (Treasury'creditReversalStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Treasury'creditReversalStatus'EnumCanceled) = "canceled"
  toJSON (Treasury'creditReversalStatus'EnumPosted) = "posted"
  toJSON (Treasury'creditReversalStatus'EnumProcessing) = "processing"

instance Data.Aeson.Types.FromJSON.FromJSON Treasury'creditReversalStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "canceled" -> Treasury'creditReversalStatus'EnumCanceled
            | val GHC.Classes.== "posted" -> Treasury'creditReversalStatus'EnumPosted
            | val GHC.Classes.== "processing" -> Treasury'creditReversalStatus'EnumProcessing
            | GHC.Base.otherwise -> Treasury'creditReversalStatus'Other val
      )

-- | Defines the oneOf schema located at @components.schemas.treasury.credit_reversal.properties.transaction.anyOf@ in the specification.
--
-- The Transaction associated with this object.
data Treasury'creditReversalTransaction'NonNullableVariants
  = Treasury'creditReversalTransaction'NonNullableText Data.Text.Internal.Text
  | Treasury'creditReversalTransaction'NonNullableTreasury'transaction Treasury'transaction
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Treasury'creditReversalTransaction'NonNullableVariants where
  toJSON (Treasury'creditReversalTransaction'NonNullableText a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (Treasury'creditReversalTransaction'NonNullableTreasury'transaction a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON Treasury'creditReversalTransaction'NonNullableVariants where
  parseJSON val = case (Treasury'creditReversalTransaction'NonNullableText Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((Treasury'creditReversalTransaction'NonNullableTreasury'transaction Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a
