{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postSetupIntents
module StripeAPI.Operations.PostSetupIntents where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/setup_intents
--
-- \<p>Creates a SetupIntent object.\<\/p>
--
-- \<p>After the SetupIntent is created, attach a payment method and \<a href=\"\/docs\/api\/setup_intents\/confirm\">confirm\<\/a>
-- to collect any required permissions to charge the payment method later.\<\/p>
postSetupIntents ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | The request body to send
  GHC.Maybe.Maybe PostSetupIntentsRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostSetupIntentsResponse)
postSetupIntents body =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either PostSetupIntentsResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostSetupIntentsResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            SetupIntent
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostSetupIntentsResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack "/v1/setup_intents") GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostSetupIntentsRequestBody = PostSetupIntentsRequestBody
  { -- | attach_to_self: If present, the SetupIntent\'s payment method will be attached to the in-context Stripe Account.
    --
    -- It can only be used for this Stripe Account’s own money movement flows like InboundTransfer and OutboundTransfers. It cannot be set to true when setting up a PaymentMethod for a Customer, and defaults to false when attaching a PaymentMethod to a Customer.
    postSetupIntentsRequestBodyAttachToSelf :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | confirm: Set to \`true\` to attempt to confirm this SetupIntent immediately. This parameter defaults to \`false\`. If the payment method attached is a card, a return_url may be provided in case additional authentication is required.
    postSetupIntentsRequestBodyConfirm :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | customer: ID of the Customer this SetupIntent belongs to, if one exists.
    --
    -- If present, the SetupIntent\'s payment method will be attached to the Customer on successful setup. Payment methods attached to other Customers cannot be used with this SetupIntent.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyCustomer :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | description: An arbitrary string attached to the object. Often useful for displaying to users.
    --
    -- Constraints:
    --
    -- * Maximum length of 1000
    postSetupIntentsRequestBodyDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | expand: Specifies which fields in the response should be expanded.
    postSetupIntentsRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | flow_directions: Indicates the directions of money movement for which this payment method is intended to be used.
    --
    -- Include \`inbound\` if you intend to use the payment method as the origin to pull funds from. Include \`outbound\` if you intend to use the payment method as the destination to send funds to. You can include both if you intend to use the payment method for both purposes.
    postSetupIntentsRequestBodyFlowDirections :: (GHC.Maybe.Maybe ([PostSetupIntentsRequestBodyFlowDirections'])),
    -- | mandate_data: This hash contains details about the Mandate to create. This parameter can only be used with [\`confirm=true\`](https:\/\/stripe.com\/docs\/api\/setup_intents\/create\#create_setup_intent-confirm).
    postSetupIntentsRequestBodyMandateData :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyMandateData'),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postSetupIntentsRequestBodyMetadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | on_behalf_of: The Stripe account ID for which this SetupIntent is created.
    postSetupIntentsRequestBodyOnBehalfOf :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | payment_method: ID of the payment method (a PaymentMethod, Card, or saved Source object) to attach to this SetupIntent.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethod :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | payment_method_data: When included, this hash creates a PaymentMethod that is set as the [\`payment_method\`](https:\/\/stripe.com\/docs\/api\/setup_intents\/object\#setup_intent_object-payment_method)
    -- value in the SetupIntent.
    postSetupIntentsRequestBodyPaymentMethodData :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'),
    -- | payment_method_options: Payment-method-specific configuration for this SetupIntent.
    postSetupIntentsRequestBodyPaymentMethodOptions :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'),
    -- | payment_method_types: The list of payment method types (e.g. card) that this SetupIntent is allowed to use. If this is not provided, defaults to [\"card\"].
    postSetupIntentsRequestBodyPaymentMethodTypes :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | return_url: The URL to redirect your customer back to after they authenticate or cancel their payment on the payment method\'s app or site. If you\'d prefer to redirect to a mobile application, you can alternatively supply an application URI scheme. This parameter can only be used with [\`confirm=true\`](https:\/\/stripe.com\/docs\/api\/setup_intents\/create\#create_setup_intent-confirm).
    postSetupIntentsRequestBodyReturnUrl :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | single_use: If this hash is populated, this SetupIntent will generate a single_use Mandate on success.
    postSetupIntentsRequestBodySingleUse :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodySingleUse'),
    -- | usage: Indicates how the payment method is intended to be used in the future. If not provided, this value defaults to \`off_session\`.
    postSetupIntentsRequestBodyUsage :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("attach_to_self" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyAttachToSelf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("confirm" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyConfirm obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyCustomer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("flow_directions" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyFlowDirections obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_data" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("on_behalf_of" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyOnBehalfOf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_data" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("single_use" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodySingleUse obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("usage" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("attach_to_self" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyAttachToSelf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("confirm" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyConfirm obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyCustomer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("flow_directions" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyFlowDirections obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_data" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("on_behalf_of" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyOnBehalfOf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_data" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("single_use" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodySingleUse obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("usage" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBody" (\obj -> (((((((((((((((GHC.Base.pure PostSetupIntentsRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "attach_to_self")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "confirm")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "customer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "flow_directions")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "mandate_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "on_behalf_of")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "return_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "single_use")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "usage"))

-- | Create a new 'PostSetupIntentsRequestBody' with all required fields.
mkPostSetupIntentsRequestBody :: PostSetupIntentsRequestBody
mkPostSetupIntentsRequestBody =
  PostSetupIntentsRequestBody
    { postSetupIntentsRequestBodyAttachToSelf = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyConfirm = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyCustomer = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyDescription = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyExpand = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyFlowDirections = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyMandateData = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyMetadata = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyOnBehalfOf = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethod = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodTypes = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyReturnUrl = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodySingleUse = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.flow_directions.items@ in the specification.
data PostSetupIntentsRequestBodyFlowDirections'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyFlowDirections'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyFlowDirections'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"inbound"@
    PostSetupIntentsRequestBodyFlowDirections'EnumInbound
  | -- | Represents the JSON value @"outbound"@
    PostSetupIntentsRequestBodyFlowDirections'EnumOutbound
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyFlowDirections' where
  toJSON (PostSetupIntentsRequestBodyFlowDirections'Other val) = val
  toJSON (PostSetupIntentsRequestBodyFlowDirections'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyFlowDirections'EnumInbound) = "inbound"
  toJSON (PostSetupIntentsRequestBodyFlowDirections'EnumOutbound) = "outbound"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyFlowDirections' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "inbound" -> PostSetupIntentsRequestBodyFlowDirections'EnumInbound
            | val GHC.Classes.== "outbound" -> PostSetupIntentsRequestBodyFlowDirections'EnumOutbound
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyFlowDirections'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.mandate_data@ in the specification.
--
-- This hash contains details about the Mandate to create. This parameter can only be used with [\`confirm=true\`](https:\/\/stripe.com\/docs\/api\/setup_intents\/create\#create_setup_intent-confirm).
data PostSetupIntentsRequestBodyMandateData' = PostSetupIntentsRequestBodyMandateData'
  { -- | customer_acceptance
    postSetupIntentsRequestBodyMandateData'CustomerAcceptance :: PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyMandateData' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["customer_acceptance" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["customer_acceptance" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyMandateData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyMandateData'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyMandateData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "customer_acceptance"))

-- | Create a new 'PostSetupIntentsRequestBodyMandateData'' with all required fields.
mkPostSetupIntentsRequestBodyMandateData' ::
  -- | 'postSetupIntentsRequestBodyMandateData'CustomerAcceptance'
  PostSetupIntentsRequestBodyMandateData'CustomerAcceptance' ->
  PostSetupIntentsRequestBodyMandateData'
mkPostSetupIntentsRequestBodyMandateData' postSetupIntentsRequestBodyMandateData'CustomerAcceptance = PostSetupIntentsRequestBodyMandateData' {postSetupIntentsRequestBodyMandateData'CustomerAcceptance = postSetupIntentsRequestBodyMandateData'CustomerAcceptance}

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.mandate_data.properties.customer_acceptance@ in the specification.
data PostSetupIntentsRequestBodyMandateData'CustomerAcceptance' = PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'
  { -- | accepted_at
    postSetupIntentsRequestBodyMandateData'CustomerAcceptance'AcceptedAt :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | offline
    postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Offline :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | online
    postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'),
    -- | type
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type :: PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyMandateData'CustomerAcceptance' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("accepted_at" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData'CustomerAcceptance'AcceptedAt obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("offline" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Offline obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("online" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online obj) : ["type" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("accepted_at" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData'CustomerAcceptance'AcceptedAt obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("offline" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Offline obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("online" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online obj) : ["type" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyMandateData'CustomerAcceptance' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'" (\obj -> (((GHC.Base.pure PostSetupIntentsRequestBodyMandateData'CustomerAcceptance' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "accepted_at")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "offline")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "online")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'' with all required fields.
mkPostSetupIntentsRequestBodyMandateData'CustomerAcceptance' ::
  -- | 'postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'
  PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type' ->
  PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'
mkPostSetupIntentsRequestBodyMandateData'CustomerAcceptance' postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type =
  PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'
    { postSetupIntentsRequestBodyMandateData'CustomerAcceptance'AcceptedAt = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Offline = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type = postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.mandate_data.properties.customer_acceptance.properties.online@ in the specification.
data PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online' = PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'
  { -- | ip_address
    postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'IpAddress :: Data.Text.Internal.Text,
    -- | user_agent
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'UserAgent :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["ip_address" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'IpAddress obj] : ["user_agent" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'UserAgent obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["ip_address" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'IpAddress obj] : ["user_agent" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'UserAgent obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'" (\obj -> (GHC.Base.pure PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "ip_address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "user_agent"))

-- | Create a new 'PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'' with all required fields.
mkPostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online' ::
  -- | 'postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'IpAddress'
  Data.Text.Internal.Text ->
  -- | 'postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'UserAgent'
  Data.Text.Internal.Text ->
  PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'
mkPostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online' postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'IpAddress postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'UserAgent =
  PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'
    { postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'IpAddress = postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'IpAddress,
      postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'UserAgent = postSetupIntentsRequestBodyMandateData'CustomerAcceptance'Online'UserAgent
    }

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.mandate_data.properties.customer_acceptance.properties.type@ in the specification.
data PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"offline"@
    PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'EnumOffline
  | -- | Represents the JSON value @"online"@
    PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'EnumOnline
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type' where
  toJSON (PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'Other val) = val
  toJSON (PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'EnumOffline) = "offline"
  toJSON (PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'EnumOnline) = "online"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "offline" -> PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'EnumOffline
            | val GHC.Classes.== "online" -> PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'EnumOnline
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyMandateData'CustomerAcceptance'Type'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data@ in the specification.
--
-- When included, this hash creates a PaymentMethod that is set as the [\`payment_method\`](https:\/\/stripe.com\/docs\/api\/setup_intents\/object\#setup_intent_object-payment_method)
-- value in the SetupIntent.
data PostSetupIntentsRequestBodyPaymentMethodData' = PostSetupIntentsRequestBodyPaymentMethodData'
  { -- | acss_debit
    postSetupIntentsRequestBodyPaymentMethodData'AcssDebit :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit'),
    -- | affirm
    postSetupIntentsRequestBodyPaymentMethodData'Affirm :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | afterpay_clearpay
    postSetupIntentsRequestBodyPaymentMethodData'AfterpayClearpay :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | alipay
    postSetupIntentsRequestBodyPaymentMethodData'Alipay :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | au_becs_debit
    postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'),
    -- | bacs_debit
    postSetupIntentsRequestBodyPaymentMethodData'BacsDebit :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit'),
    -- | bancontact
    postSetupIntentsRequestBodyPaymentMethodData'Bancontact :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | billing_details
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'),
    -- | boleto
    postSetupIntentsRequestBodyPaymentMethodData'Boleto :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Boleto'),
    -- | customer_balance
    postSetupIntentsRequestBodyPaymentMethodData'CustomerBalance :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | eps
    postSetupIntentsRequestBodyPaymentMethodData'Eps :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Eps'),
    -- | fpx
    postSetupIntentsRequestBodyPaymentMethodData'Fpx :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Fpx'),
    -- | giropay
    postSetupIntentsRequestBodyPaymentMethodData'Giropay :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | grabpay
    postSetupIntentsRequestBodyPaymentMethodData'Grabpay :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | ideal
    postSetupIntentsRequestBodyPaymentMethodData'Ideal :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Ideal'),
    -- | interac_present
    postSetupIntentsRequestBodyPaymentMethodData'InteracPresent :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | klarna
    postSetupIntentsRequestBodyPaymentMethodData'Klarna :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Klarna'),
    -- | konbini
    postSetupIntentsRequestBodyPaymentMethodData'Konbini :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | link
    postSetupIntentsRequestBodyPaymentMethodData'Link :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | metadata
    postSetupIntentsRequestBodyPaymentMethodData'Metadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | oxxo
    postSetupIntentsRequestBodyPaymentMethodData'Oxxo :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | p24
    postSetupIntentsRequestBodyPaymentMethodData'P24 :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'P24'),
    -- | paynow
    postSetupIntentsRequestBodyPaymentMethodData'Paynow :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | promptpay
    postSetupIntentsRequestBodyPaymentMethodData'Promptpay :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | radar_options
    postSetupIntentsRequestBodyPaymentMethodData'RadarOptions :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions'),
    -- | sepa_debit
    postSetupIntentsRequestBodyPaymentMethodData'SepaDebit :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit'),
    -- | sofort
    postSetupIntentsRequestBodyPaymentMethodData'Sofort :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Sofort'),
    -- | type
    postSetupIntentsRequestBodyPaymentMethodData'Type :: PostSetupIntentsRequestBodyPaymentMethodData'Type',
    -- | us_bank_account
    postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'),
    -- | wechat_pay
    postSetupIntentsRequestBodyPaymentMethodData'WechatPay :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("acss_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'AcssDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("affirm" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Affirm obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("afterpay_clearpay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'AfterpayClearpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("alipay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Alipay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("au_becs_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bacs_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BacsDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bancontact" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Bancontact obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_details" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("boleto" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Boleto obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_balance" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'CustomerBalance obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eps" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Eps obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fpx" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Fpx obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("giropay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Giropay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("grabpay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Grabpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("ideal" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Ideal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interac_present" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'InteracPresent obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("klarna" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Klarna obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("konbini" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Konbini obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("link" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Link obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Metadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("oxxo" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Oxxo obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("p24" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'P24 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("paynow" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Paynow obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promptpay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Promptpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("radar_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'RadarOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'SepaDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sofort" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Sofort obj) : ["type" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Type obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("us_bank_account" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("wechat_pay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'WechatPay obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("acss_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'AcssDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("affirm" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Affirm obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("afterpay_clearpay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'AfterpayClearpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("alipay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Alipay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("au_becs_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bacs_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BacsDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bancontact" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Bancontact obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_details" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("boleto" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Boleto obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_balance" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'CustomerBalance obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eps" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Eps obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fpx" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Fpx obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("giropay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Giropay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("grabpay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Grabpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("ideal" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Ideal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interac_present" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'InteracPresent obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("klarna" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Klarna obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("konbini" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Konbini obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("link" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Link obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Metadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("oxxo" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Oxxo obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("p24" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'P24 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("paynow" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Paynow obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promptpay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Promptpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("radar_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'RadarOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'SepaDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sofort" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Sofort obj) : ["type" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Type obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("us_bank_account" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("wechat_pay" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'WechatPay obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'" (\obj -> (((((((((((((((((((((((((((((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "acss_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "affirm")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "afterpay_clearpay")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "alipay")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "au_becs_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bacs_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bancontact")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "billing_details")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "boleto")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "customer_balance")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "eps")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fpx")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "giropay")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "grabpay")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "ideal")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "interac_present")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "klarna")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "konbini")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "link")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "oxxo")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "p24")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "paynow")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "promptpay")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "radar_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sepa_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sofort")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "us_bank_account")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "wechat_pay"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'Type'
  PostSetupIntentsRequestBodyPaymentMethodData'Type' ->
  PostSetupIntentsRequestBodyPaymentMethodData'
mkPostSetupIntentsRequestBodyPaymentMethodData' postSetupIntentsRequestBodyPaymentMethodData'Type =
  PostSetupIntentsRequestBodyPaymentMethodData'
    { postSetupIntentsRequestBodyPaymentMethodData'AcssDebit = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Affirm = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'AfterpayClearpay = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Alipay = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BacsDebit = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Bancontact = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Boleto = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'CustomerBalance = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Eps = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Fpx = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Giropay = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Grabpay = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Ideal = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'InteracPresent = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Klarna = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Konbini = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Link = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Metadata = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Oxxo = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'P24 = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Paynow = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Promptpay = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'RadarOptions = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'SepaDebit = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Sofort = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'Type = postSetupIntentsRequestBodyPaymentMethodData'Type,
      postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'WechatPay = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.acss_debit@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit' = PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit'
  { -- | account_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'AccountNumber :: Data.Text.Internal.Text,
    -- | institution_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'InstitutionNumber :: Data.Text.Internal.Text,
    -- | transit_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'TransitNumber :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["account_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'AccountNumber obj] : ["institution_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'InstitutionNumber obj] : ["transit_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'TransitNumber obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["account_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'AccountNumber obj] : ["institution_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'InstitutionNumber obj] : ["transit_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'TransitNumber obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit'" (\obj -> ((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "account_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "institution_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "transit_number"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'AcssDebit' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'AccountNumber'
  Data.Text.Internal.Text ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'InstitutionNumber'
  Data.Text.Internal.Text ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'TransitNumber'
  Data.Text.Internal.Text ->
  PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit'
mkPostSetupIntentsRequestBodyPaymentMethodData'AcssDebit' postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'AccountNumber postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'InstitutionNumber postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'TransitNumber =
  PostSetupIntentsRequestBodyPaymentMethodData'AcssDebit'
    { postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'AccountNumber = postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'AccountNumber,
      postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'InstitutionNumber = postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'InstitutionNumber,
      postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'TransitNumber = postSetupIntentsRequestBodyPaymentMethodData'AcssDebit'TransitNumber
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.au_becs_debit@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit' = PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'
  { -- | account_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'AccountNumber :: Data.Text.Internal.Text,
    -- | bsb_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'BsbNumber :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["account_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'AccountNumber obj] : ["bsb_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'BsbNumber obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["account_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'AccountNumber obj] : ["bsb_number" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'BsbNumber obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'" (\obj -> (GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "account_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "bsb_number"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'AccountNumber'
  Data.Text.Internal.Text ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'BsbNumber'
  Data.Text.Internal.Text ->
  PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'
mkPostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit' postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'AccountNumber postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'BsbNumber =
  PostSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'
    { postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'AccountNumber = postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'AccountNumber,
      postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'BsbNumber = postSetupIntentsRequestBodyPaymentMethodData'AuBecsDebit'BsbNumber
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.bacs_debit@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit' = PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit'
  { -- | account_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'AccountNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | sort_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'SortCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_number" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'AccountNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sort_code" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'SortCode obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_number" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'AccountNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sort_code" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'SortCode obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit'" (\obj -> (GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "account_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sort_code"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'BacsDebit' :: PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit'
mkPostSetupIntentsRequestBodyPaymentMethodData'BacsDebit' =
  PostSetupIntentsRequestBodyPaymentMethodData'BacsDebit'
    { postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'AccountNumber = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BacsDebit'SortCode = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.billing_details@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails' = PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'
  { -- | address
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'Variants),
    -- | email
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'Variants),
    -- | name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Name :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | phone
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Phone :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("address" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("name" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Name obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Phone obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("address" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("name" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Name obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Phone obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'" (\obj -> (((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "phone"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'BillingDetails' :: PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'
mkPostSetupIntentsRequestBodyPaymentMethodData'BillingDetails' =
  PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'
    { postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Name = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Phone = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.billing_details.properties.address.anyOf@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 = PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1
  { -- | city
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1City :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Country :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line1
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line1 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line2
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line2 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | postal_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1PostalCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | state
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1State :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("city" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1City obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("country" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Country obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line1" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line1 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line2 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("postal_code" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1PostalCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1State obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("city" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1City obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("country" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Country obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line1" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line1 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line2 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("postal_code" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1PostalCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1State obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1" (\obj -> (((((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "city")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line1")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line2")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "postal_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "state"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 :: PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1
mkPostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 =
  PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1
    { postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1City = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Country = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line1 = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1Line2 = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1PostalCode = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1State = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.billing_details.properties.address.anyOf@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'Variants
  = -- | Represents the JSON value @""@
    PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'EmptyString
  | PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'Variants where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'EmptyString
        | GHC.Base.otherwise -> case (PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Address'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.billing_details.properties.email.anyOf@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'Variants
  = -- | Represents the JSON value @""@
    PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'EmptyString
  | PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'Variants where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'EmptyString
        | GHC.Base.otherwise -> case (PostSetupIntentsRequestBodyPaymentMethodData'BillingDetails'Email'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.boleto@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Boleto' = PostSetupIntentsRequestBodyPaymentMethodData'Boleto'
  { -- | tax_id
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'Boleto'TaxId :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Boleto' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["tax_id" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Boleto'TaxId obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["tax_id" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Boleto'TaxId obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Boleto' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'Boleto'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'Boleto' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "tax_id"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'Boleto'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'Boleto' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'Boleto'TaxId'
  Data.Text.Internal.Text ->
  PostSetupIntentsRequestBodyPaymentMethodData'Boleto'
mkPostSetupIntentsRequestBodyPaymentMethodData'Boleto' postSetupIntentsRequestBodyPaymentMethodData'Boleto'TaxId = PostSetupIntentsRequestBodyPaymentMethodData'Boleto' {postSetupIntentsRequestBodyPaymentMethodData'Boleto'TaxId = postSetupIntentsRequestBodyPaymentMethodData'Boleto'TaxId}

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.eps@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Eps' = PostSetupIntentsRequestBodyPaymentMethodData'Eps'
  { -- | bank
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'Eps'Bank :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Eps' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Eps'Bank obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Eps'Bank obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Eps' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'Eps'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'Eps' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bank"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'Eps'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'Eps' :: PostSetupIntentsRequestBodyPaymentMethodData'Eps'
mkPostSetupIntentsRequestBodyPaymentMethodData'Eps' = PostSetupIntentsRequestBodyPaymentMethodData'Eps' {postSetupIntentsRequestBodyPaymentMethodData'Eps'Bank = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.eps.properties.bank@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"arzte_und_apotheker_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumArzteUndApothekerBank
  | -- | Represents the JSON value @"austrian_anadi_bank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumAustrianAnadiBankAg
  | -- | Represents the JSON value @"bank_austria"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankAustria
  | -- | Represents the JSON value @"bankhaus_carl_spangler"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankhausCarlSpangler
  | -- | Represents the JSON value @"bankhaus_schelhammer_und_schattera_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankhausSchelhammerUndSchatteraAg
  | -- | Represents the JSON value @"bawag_psk_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBawagPskAg
  | -- | Represents the JSON value @"bks_bank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBksBankAg
  | -- | Represents the JSON value @"brull_kallmus_bank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBrullKallmusBankAg
  | -- | Represents the JSON value @"btv_vier_lander_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBtvVierLanderBank
  | -- | Represents the JSON value @"capital_bank_grawe_gruppe_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumCapitalBankGraweGruppeAg
  | -- | Represents the JSON value @"dolomitenbank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumDolomitenbank
  | -- | Represents the JSON value @"easybank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumEasybankAg
  | -- | Represents the JSON value @"erste_bank_und_sparkassen"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumErsteBankUndSparkassen
  | -- | Represents the JSON value @"hypo_alpeadriabank_international_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoAlpeadriabankInternationalAg
  | -- | Represents the JSON value @"hypo_bank_burgenland_aktiengesellschaft"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoBankBurgenlandAktiengesellschaft
  | -- | Represents the JSON value @"hypo_noe_lb_fur_niederosterreich_u_wien"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoNoeLbFurNiederosterreichUWien
  | -- | Represents the JSON value @"hypo_oberosterreich_salzburg_steiermark"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoOberosterreichSalzburgSteiermark
  | -- | Represents the JSON value @"hypo_tirol_bank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoTirolBankAg
  | -- | Represents the JSON value @"hypo_vorarlberg_bank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoVorarlbergBankAg
  | -- | Represents the JSON value @"marchfelder_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumMarchfelderBank
  | -- | Represents the JSON value @"oberbank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumOberbankAg
  | -- | Represents the JSON value @"raiffeisen_bankengruppe_osterreich"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumRaiffeisenBankengruppeOsterreich
  | -- | Represents the JSON value @"schoellerbank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumSchoellerbankAg
  | -- | Represents the JSON value @"sparda_bank_wien"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumSpardaBankWien
  | -- | Represents the JSON value @"volksbank_gruppe"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVolksbankGruppe
  | -- | Represents the JSON value @"volkskreditbank_ag"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVolkskreditbankAg
  | -- | Represents the JSON value @"vr_bank_braunau"@
    PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVrBankBraunau
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumArzteUndApothekerBank) = "arzte_und_apotheker_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumAustrianAnadiBankAg) = "austrian_anadi_bank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankAustria) = "bank_austria"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankhausCarlSpangler) = "bankhaus_carl_spangler"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankhausSchelhammerUndSchatteraAg) = "bankhaus_schelhammer_und_schattera_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBawagPskAg) = "bawag_psk_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBksBankAg) = "bks_bank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBrullKallmusBankAg) = "brull_kallmus_bank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBtvVierLanderBank) = "btv_vier_lander_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumCapitalBankGraweGruppeAg) = "capital_bank_grawe_gruppe_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumDolomitenbank) = "dolomitenbank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumEasybankAg) = "easybank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumErsteBankUndSparkassen) = "erste_bank_und_sparkassen"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoAlpeadriabankInternationalAg) = "hypo_alpeadriabank_international_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoBankBurgenlandAktiengesellschaft) = "hypo_bank_burgenland_aktiengesellschaft"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoNoeLbFurNiederosterreichUWien) = "hypo_noe_lb_fur_niederosterreich_u_wien"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoOberosterreichSalzburgSteiermark) = "hypo_oberosterreich_salzburg_steiermark"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoTirolBankAg) = "hypo_tirol_bank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoVorarlbergBankAg) = "hypo_vorarlberg_bank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumMarchfelderBank) = "marchfelder_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumOberbankAg) = "oberbank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumRaiffeisenBankengruppeOsterreich) = "raiffeisen_bankengruppe_osterreich"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumSchoellerbankAg) = "schoellerbank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumSpardaBankWien) = "sparda_bank_wien"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVolksbankGruppe) = "volksbank_gruppe"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVolkskreditbankAg) = "volkskreditbank_ag"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVrBankBraunau) = "vr_bank_braunau"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "arzte_und_apotheker_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumArzteUndApothekerBank
            | val GHC.Classes.== "austrian_anadi_bank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumAustrianAnadiBankAg
            | val GHC.Classes.== "bank_austria" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankAustria
            | val GHC.Classes.== "bankhaus_carl_spangler" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankhausCarlSpangler
            | val GHC.Classes.== "bankhaus_schelhammer_und_schattera_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBankhausSchelhammerUndSchatteraAg
            | val GHC.Classes.== "bawag_psk_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBawagPskAg
            | val GHC.Classes.== "bks_bank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBksBankAg
            | val GHC.Classes.== "brull_kallmus_bank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBrullKallmusBankAg
            | val GHC.Classes.== "btv_vier_lander_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumBtvVierLanderBank
            | val GHC.Classes.== "capital_bank_grawe_gruppe_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumCapitalBankGraweGruppeAg
            | val GHC.Classes.== "dolomitenbank" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumDolomitenbank
            | val GHC.Classes.== "easybank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumEasybankAg
            | val GHC.Classes.== "erste_bank_und_sparkassen" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumErsteBankUndSparkassen
            | val GHC.Classes.== "hypo_alpeadriabank_international_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoAlpeadriabankInternationalAg
            | val GHC.Classes.== "hypo_bank_burgenland_aktiengesellschaft" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoBankBurgenlandAktiengesellschaft
            | val GHC.Classes.== "hypo_noe_lb_fur_niederosterreich_u_wien" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoNoeLbFurNiederosterreichUWien
            | val GHC.Classes.== "hypo_oberosterreich_salzburg_steiermark" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoOberosterreichSalzburgSteiermark
            | val GHC.Classes.== "hypo_tirol_bank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoTirolBankAg
            | val GHC.Classes.== "hypo_vorarlberg_bank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumHypoVorarlbergBankAg
            | val GHC.Classes.== "marchfelder_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumMarchfelderBank
            | val GHC.Classes.== "oberbank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumOberbankAg
            | val GHC.Classes.== "raiffeisen_bankengruppe_osterreich" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumRaiffeisenBankengruppeOsterreich
            | val GHC.Classes.== "schoellerbank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumSchoellerbankAg
            | val GHC.Classes.== "sparda_bank_wien" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumSpardaBankWien
            | val GHC.Classes.== "volksbank_gruppe" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVolksbankGruppe
            | val GHC.Classes.== "volkskreditbank_ag" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVolkskreditbankAg
            | val GHC.Classes.== "vr_bank_braunau" -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'EnumVrBankBraunau
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'Eps'Bank'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.fpx@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Fpx' = PostSetupIntentsRequestBodyPaymentMethodData'Fpx'
  { -- | bank
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank :: PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Fpx' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["bank" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["bank" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Fpx' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'Fpx'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'Fpx' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "bank"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'Fpx'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'Fpx' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'
  PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank' ->
  PostSetupIntentsRequestBodyPaymentMethodData'Fpx'
mkPostSetupIntentsRequestBodyPaymentMethodData'Fpx' postSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank = PostSetupIntentsRequestBodyPaymentMethodData'Fpx' {postSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank = postSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank}

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.fpx.properties.bank@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"affin_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAffinBank
  | -- | Represents the JSON value @"agrobank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAgrobank
  | -- | Represents the JSON value @"alliance_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAllianceBank
  | -- | Represents the JSON value @"ambank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAmbank
  | -- | Represents the JSON value @"bank_islam"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankIslam
  | -- | Represents the JSON value @"bank_muamalat"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankMuamalat
  | -- | Represents the JSON value @"bank_rakyat"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankRakyat
  | -- | Represents the JSON value @"bsn"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBsn
  | -- | Represents the JSON value @"cimb"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumCimb
  | -- | Represents the JSON value @"deutsche_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumDeutscheBank
  | -- | Represents the JSON value @"hong_leong_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumHongLeongBank
  | -- | Represents the JSON value @"hsbc"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumHsbc
  | -- | Represents the JSON value @"kfh"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumKfh
  | -- | Represents the JSON value @"maybank2e"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumMaybank2e
  | -- | Represents the JSON value @"maybank2u"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumMaybank2u
  | -- | Represents the JSON value @"ocbc"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumOcbc
  | -- | Represents the JSON value @"pb_enterprise"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumPbEnterprise
  | -- | Represents the JSON value @"public_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumPublicBank
  | -- | Represents the JSON value @"rhb"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumRhb
  | -- | Represents the JSON value @"standard_chartered"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumStandardChartered
  | -- | Represents the JSON value @"uob"@
    PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumUob
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAffinBank) = "affin_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAgrobank) = "agrobank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAllianceBank) = "alliance_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAmbank) = "ambank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankIslam) = "bank_islam"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankMuamalat) = "bank_muamalat"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankRakyat) = "bank_rakyat"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBsn) = "bsn"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumCimb) = "cimb"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumDeutscheBank) = "deutsche_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumHongLeongBank) = "hong_leong_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumHsbc) = "hsbc"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumKfh) = "kfh"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumMaybank2e) = "maybank2e"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumMaybank2u) = "maybank2u"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumOcbc) = "ocbc"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumPbEnterprise) = "pb_enterprise"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumPublicBank) = "public_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumRhb) = "rhb"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumStandardChartered) = "standard_chartered"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumUob) = "uob"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "affin_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAffinBank
            | val GHC.Classes.== "agrobank" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAgrobank
            | val GHC.Classes.== "alliance_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAllianceBank
            | val GHC.Classes.== "ambank" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumAmbank
            | val GHC.Classes.== "bank_islam" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankIslam
            | val GHC.Classes.== "bank_muamalat" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankMuamalat
            | val GHC.Classes.== "bank_rakyat" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBankRakyat
            | val GHC.Classes.== "bsn" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumBsn
            | val GHC.Classes.== "cimb" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumCimb
            | val GHC.Classes.== "deutsche_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumDeutscheBank
            | val GHC.Classes.== "hong_leong_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumHongLeongBank
            | val GHC.Classes.== "hsbc" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumHsbc
            | val GHC.Classes.== "kfh" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumKfh
            | val GHC.Classes.== "maybank2e" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumMaybank2e
            | val GHC.Classes.== "maybank2u" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumMaybank2u
            | val GHC.Classes.== "ocbc" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumOcbc
            | val GHC.Classes.== "pb_enterprise" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumPbEnterprise
            | val GHC.Classes.== "public_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumPublicBank
            | val GHC.Classes.== "rhb" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumRhb
            | val GHC.Classes.== "standard_chartered" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumStandardChartered
            | val GHC.Classes.== "uob" -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'EnumUob
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'Fpx'Bank'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.ideal@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Ideal' = PostSetupIntentsRequestBodyPaymentMethodData'Ideal'
  { -- | bank
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Ideal' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Ideal' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'Ideal'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'Ideal' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bank"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'Ideal'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'Ideal' :: PostSetupIntentsRequestBodyPaymentMethodData'Ideal'
mkPostSetupIntentsRequestBodyPaymentMethodData'Ideal' = PostSetupIntentsRequestBodyPaymentMethodData'Ideal' {postSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.ideal.properties.bank@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"abn_amro"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumAbnAmro
  | -- | Represents the JSON value @"asn_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumAsnBank
  | -- | Represents the JSON value @"bunq"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumBunq
  | -- | Represents the JSON value @"handelsbanken"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumHandelsbanken
  | -- | Represents the JSON value @"ing"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumIng
  | -- | Represents the JSON value @"knab"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumKnab
  | -- | Represents the JSON value @"moneyou"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumMoneyou
  | -- | Represents the JSON value @"rabobank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRabobank
  | -- | Represents the JSON value @"regiobank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRegiobank
  | -- | Represents the JSON value @"revolut"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRevolut
  | -- | Represents the JSON value @"sns_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumSnsBank
  | -- | Represents the JSON value @"triodos_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumTriodosBank
  | -- | Represents the JSON value @"van_lanschot"@
    PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumVanLanschot
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumAbnAmro) = "abn_amro"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumAsnBank) = "asn_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumBunq) = "bunq"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumHandelsbanken) = "handelsbanken"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumIng) = "ing"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumKnab) = "knab"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumMoneyou) = "moneyou"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRabobank) = "rabobank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRegiobank) = "regiobank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRevolut) = "revolut"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumSnsBank) = "sns_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumTriodosBank) = "triodos_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumVanLanschot) = "van_lanschot"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "abn_amro" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumAbnAmro
            | val GHC.Classes.== "asn_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumAsnBank
            | val GHC.Classes.== "bunq" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumBunq
            | val GHC.Classes.== "handelsbanken" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumHandelsbanken
            | val GHC.Classes.== "ing" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumIng
            | val GHC.Classes.== "knab" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumKnab
            | val GHC.Classes.== "moneyou" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumMoneyou
            | val GHC.Classes.== "rabobank" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRabobank
            | val GHC.Classes.== "regiobank" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRegiobank
            | val GHC.Classes.== "revolut" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumRevolut
            | val GHC.Classes.== "sns_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumSnsBank
            | val GHC.Classes.== "triodos_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumTriodosBank
            | val GHC.Classes.== "van_lanschot" -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'EnumVanLanschot
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'Ideal'Bank'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.klarna@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Klarna' = PostSetupIntentsRequestBodyPaymentMethodData'Klarna'
  { -- | dob
    postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Klarna' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dob" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dob" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Klarna' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'Klarna'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'Klarna' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "dob"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'Klarna'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'Klarna' :: PostSetupIntentsRequestBodyPaymentMethodData'Klarna'
mkPostSetupIntentsRequestBodyPaymentMethodData'Klarna' = PostSetupIntentsRequestBodyPaymentMethodData'Klarna' {postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.klarna.properties.dob@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob' = PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'
  { -- | day
    postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Day :: GHC.Types.Int,
    -- | month
    postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Month :: GHC.Types.Int,
    -- | year
    postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Year :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["day" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Day obj] : ["month" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Month obj] : ["year" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Year obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["day" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Day obj] : ["month" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Month obj] : ["year" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Year obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'" (\obj -> ((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "day")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "month")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "year"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Day'
  GHC.Types.Int ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Month'
  GHC.Types.Int ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Year'
  GHC.Types.Int ->
  PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'
mkPostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob' postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Day postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Month postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Year =
  PostSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'
    { postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Day = postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Day,
      postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Month = postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Month,
      postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Year = postSetupIntentsRequestBodyPaymentMethodData'Klarna'Dob'Year
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.p24@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'P24' = PostSetupIntentsRequestBodyPaymentMethodData'P24'
  { -- | bank
    postSetupIntentsRequestBodyPaymentMethodData'P24'Bank :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'P24' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'P24'Bank obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'P24'Bank obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'P24' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'P24'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'P24' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bank"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'P24'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'P24' :: PostSetupIntentsRequestBodyPaymentMethodData'P24'
mkPostSetupIntentsRequestBodyPaymentMethodData'P24' = PostSetupIntentsRequestBodyPaymentMethodData'P24' {postSetupIntentsRequestBodyPaymentMethodData'P24'Bank = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.p24.properties.bank@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"alior_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumAliorBank
  | -- | Represents the JSON value @"bank_millennium"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankMillennium
  | -- | Represents the JSON value @"bank_nowy_bfg_sa"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankNowyBfgSa
  | -- | Represents the JSON value @"bank_pekao_sa"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankPekaoSa
  | -- | Represents the JSON value @"banki_spbdzielcze"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankiSpbdzielcze
  | -- | Represents the JSON value @"blik"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBlik
  | -- | Represents the JSON value @"bnp_paribas"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBnpParibas
  | -- | Represents the JSON value @"boz"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBoz
  | -- | Represents the JSON value @"citi_handlowy"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumCitiHandlowy
  | -- | Represents the JSON value @"credit_agricole"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumCreditAgricole
  | -- | Represents the JSON value @"envelobank"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumEnvelobank
  | -- | Represents the JSON value @"etransfer_pocztowy24"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumEtransferPocztowy24
  | -- | Represents the JSON value @"getin_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumGetinBank
  | -- | Represents the JSON value @"ideabank"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumIdeabank
  | -- | Represents the JSON value @"ing"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumIng
  | -- | Represents the JSON value @"inteligo"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumInteligo
  | -- | Represents the JSON value @"mbank_mtransfer"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumMbankMtransfer
  | -- | Represents the JSON value @"nest_przelew"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumNestPrzelew
  | -- | Represents the JSON value @"noble_pay"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumNoblePay
  | -- | Represents the JSON value @"pbac_z_ipko"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumPbacZIpko
  | -- | Represents the JSON value @"plus_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumPlusBank
  | -- | Represents the JSON value @"santander_przelew24"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumSantanderPrzelew24
  | -- | Represents the JSON value @"tmobile_usbugi_bankowe"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumTmobileUsbugiBankowe
  | -- | Represents the JSON value @"toyota_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumToyotaBank
  | -- | Represents the JSON value @"volkswagen_bank"@
    PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumVolkswagenBank
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumAliorBank) = "alior_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankMillennium) = "bank_millennium"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankNowyBfgSa) = "bank_nowy_bfg_sa"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankPekaoSa) = "bank_pekao_sa"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankiSpbdzielcze) = "banki_spbdzielcze"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBlik) = "blik"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBnpParibas) = "bnp_paribas"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBoz) = "boz"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumCitiHandlowy) = "citi_handlowy"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumCreditAgricole) = "credit_agricole"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumEnvelobank) = "envelobank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumEtransferPocztowy24) = "etransfer_pocztowy24"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumGetinBank) = "getin_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumIdeabank) = "ideabank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumIng) = "ing"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumInteligo) = "inteligo"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumMbankMtransfer) = "mbank_mtransfer"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumNestPrzelew) = "nest_przelew"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumNoblePay) = "noble_pay"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumPbacZIpko) = "pbac_z_ipko"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumPlusBank) = "plus_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumSantanderPrzelew24) = "santander_przelew24"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumTmobileUsbugiBankowe) = "tmobile_usbugi_bankowe"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumToyotaBank) = "toyota_bank"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumVolkswagenBank) = "volkswagen_bank"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "alior_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumAliorBank
            | val GHC.Classes.== "bank_millennium" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankMillennium
            | val GHC.Classes.== "bank_nowy_bfg_sa" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankNowyBfgSa
            | val GHC.Classes.== "bank_pekao_sa" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankPekaoSa
            | val GHC.Classes.== "banki_spbdzielcze" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBankiSpbdzielcze
            | val GHC.Classes.== "blik" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBlik
            | val GHC.Classes.== "bnp_paribas" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBnpParibas
            | val GHC.Classes.== "boz" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumBoz
            | val GHC.Classes.== "citi_handlowy" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumCitiHandlowy
            | val GHC.Classes.== "credit_agricole" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumCreditAgricole
            | val GHC.Classes.== "envelobank" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumEnvelobank
            | val GHC.Classes.== "etransfer_pocztowy24" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumEtransferPocztowy24
            | val GHC.Classes.== "getin_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumGetinBank
            | val GHC.Classes.== "ideabank" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumIdeabank
            | val GHC.Classes.== "ing" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumIng
            | val GHC.Classes.== "inteligo" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumInteligo
            | val GHC.Classes.== "mbank_mtransfer" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumMbankMtransfer
            | val GHC.Classes.== "nest_przelew" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumNestPrzelew
            | val GHC.Classes.== "noble_pay" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumNoblePay
            | val GHC.Classes.== "pbac_z_ipko" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumPbacZIpko
            | val GHC.Classes.== "plus_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumPlusBank
            | val GHC.Classes.== "santander_przelew24" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumSantanderPrzelew24
            | val GHC.Classes.== "tmobile_usbugi_bankowe" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumTmobileUsbugiBankowe
            | val GHC.Classes.== "toyota_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumToyotaBank
            | val GHC.Classes.== "volkswagen_bank" -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'EnumVolkswagenBank
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'P24'Bank'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.radar_options@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions' = PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions'
  { -- | session
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'RadarOptions'Session :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("session" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'RadarOptions'Session obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("session" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'RadarOptions'Session obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "session"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'RadarOptions' :: PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions'
mkPostSetupIntentsRequestBodyPaymentMethodData'RadarOptions' = PostSetupIntentsRequestBodyPaymentMethodData'RadarOptions' {postSetupIntentsRequestBodyPaymentMethodData'RadarOptions'Session = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.sepa_debit@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit' = PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit'
  { -- | iban
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'SepaDebit'Iban :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["iban" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'SepaDebit'Iban obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["iban" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'SepaDebit'Iban obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "iban"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'SepaDebit' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'SepaDebit'Iban'
  Data.Text.Internal.Text ->
  PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit'
mkPostSetupIntentsRequestBodyPaymentMethodData'SepaDebit' postSetupIntentsRequestBodyPaymentMethodData'SepaDebit'Iban = PostSetupIntentsRequestBodyPaymentMethodData'SepaDebit' {postSetupIntentsRequestBodyPaymentMethodData'SepaDebit'Iban = postSetupIntentsRequestBodyPaymentMethodData'SepaDebit'Iban}

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.sofort@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Sofort' = PostSetupIntentsRequestBodyPaymentMethodData'Sofort'
  { -- | country
    postSetupIntentsRequestBodyPaymentMethodData'Sofort'Country :: PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Sofort' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["country" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Sofort'Country obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["country" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodData'Sofort'Country obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Sofort' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'Sofort'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'Sofort' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "country"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'Sofort'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'Sofort' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'
  PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country' ->
  PostSetupIntentsRequestBodyPaymentMethodData'Sofort'
mkPostSetupIntentsRequestBodyPaymentMethodData'Sofort' postSetupIntentsRequestBodyPaymentMethodData'Sofort'Country = PostSetupIntentsRequestBodyPaymentMethodData'Sofort' {postSetupIntentsRequestBodyPaymentMethodData'Sofort'Country = postSetupIntentsRequestBodyPaymentMethodData'Sofort'Country}

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.sofort.properties.country@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"AT"@
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumAT
  | -- | Represents the JSON value @"BE"@
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumBE
  | -- | Represents the JSON value @"DE"@
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumDE
  | -- | Represents the JSON value @"ES"@
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumES
  | -- | Represents the JSON value @"IT"@
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumIT
  | -- | Represents the JSON value @"NL"@
    PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumNL
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumAT) = "AT"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumBE) = "BE"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumDE) = "DE"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumES) = "ES"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumIT) = "IT"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumNL) = "NL"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "AT" -> PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumAT
            | val GHC.Classes.== "BE" -> PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumBE
            | val GHC.Classes.== "DE" -> PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumDE
            | val GHC.Classes.== "ES" -> PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumES
            | val GHC.Classes.== "IT" -> PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumIT
            | val GHC.Classes.== "NL" -> PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'EnumNL
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'Sofort'Country'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.type@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"acss_debit"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAcssDebit
  | -- | Represents the JSON value @"affirm"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAffirm
  | -- | Represents the JSON value @"afterpay_clearpay"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAfterpayClearpay
  | -- | Represents the JSON value @"alipay"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAlipay
  | -- | Represents the JSON value @"au_becs_debit"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAuBecsDebit
  | -- | Represents the JSON value @"bacs_debit"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBacsDebit
  | -- | Represents the JSON value @"bancontact"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBancontact
  | -- | Represents the JSON value @"boleto"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBoleto
  | -- | Represents the JSON value @"customer_balance"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumCustomerBalance
  | -- | Represents the JSON value @"eps"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumEps
  | -- | Represents the JSON value @"fpx"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumFpx
  | -- | Represents the JSON value @"giropay"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumGiropay
  | -- | Represents the JSON value @"grabpay"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumGrabpay
  | -- | Represents the JSON value @"ideal"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumIdeal
  | -- | Represents the JSON value @"klarna"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumKlarna
  | -- | Represents the JSON value @"konbini"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumKonbini
  | -- | Represents the JSON value @"link"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumLink
  | -- | Represents the JSON value @"oxxo"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumOxxo
  | -- | Represents the JSON value @"p24"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumP24
  | -- | Represents the JSON value @"paynow"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumPaynow
  | -- | Represents the JSON value @"promptpay"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumPromptpay
  | -- | Represents the JSON value @"sepa_debit"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumSepaDebit
  | -- | Represents the JSON value @"sofort"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumSofort
  | -- | Represents the JSON value @"us_bank_account"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumUsBankAccount
  | -- | Represents the JSON value @"wechat_pay"@
    PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumWechatPay
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'Type' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAcssDebit) = "acss_debit"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAffirm) = "affirm"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAfterpayClearpay) = "afterpay_clearpay"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAlipay) = "alipay"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAuBecsDebit) = "au_becs_debit"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBacsDebit) = "bacs_debit"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBancontact) = "bancontact"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBoleto) = "boleto"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumCustomerBalance) = "customer_balance"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumEps) = "eps"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumFpx) = "fpx"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumGiropay) = "giropay"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumGrabpay) = "grabpay"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumIdeal) = "ideal"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumKlarna) = "klarna"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumKonbini) = "konbini"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumLink) = "link"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumOxxo) = "oxxo"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumP24) = "p24"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumPaynow) = "paynow"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumPromptpay) = "promptpay"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumSepaDebit) = "sepa_debit"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumSofort) = "sofort"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumUsBankAccount) = "us_bank_account"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumWechatPay) = "wechat_pay"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "acss_debit" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAcssDebit
            | val GHC.Classes.== "affirm" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAffirm
            | val GHC.Classes.== "afterpay_clearpay" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAfterpayClearpay
            | val GHC.Classes.== "alipay" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAlipay
            | val GHC.Classes.== "au_becs_debit" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumAuBecsDebit
            | val GHC.Classes.== "bacs_debit" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBacsDebit
            | val GHC.Classes.== "bancontact" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBancontact
            | val GHC.Classes.== "boleto" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumBoleto
            | val GHC.Classes.== "customer_balance" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumCustomerBalance
            | val GHC.Classes.== "eps" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumEps
            | val GHC.Classes.== "fpx" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumFpx
            | val GHC.Classes.== "giropay" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumGiropay
            | val GHC.Classes.== "grabpay" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumGrabpay
            | val GHC.Classes.== "ideal" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumIdeal
            | val GHC.Classes.== "klarna" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumKlarna
            | val GHC.Classes.== "konbini" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumKonbini
            | val GHC.Classes.== "link" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumLink
            | val GHC.Classes.== "oxxo" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumOxxo
            | val GHC.Classes.== "p24" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumP24
            | val GHC.Classes.== "paynow" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumPaynow
            | val GHC.Classes.== "promptpay" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumPromptpay
            | val GHC.Classes.== "sepa_debit" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumSepaDebit
            | val GHC.Classes.== "sofort" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumSofort
            | val GHC.Classes.== "us_bank_account" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumUsBankAccount
            | val GHC.Classes.== "wechat_pay" -> PostSetupIntentsRequestBodyPaymentMethodData'Type'EnumWechatPay
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'Type'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.us_bank_account@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount' = PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'
  { -- | account_holder_type
    postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'),
    -- | account_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | account_type
    postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'),
    -- | financial_connections_account
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'FinancialConnectionsAccount :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | routing_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'RoutingNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_holder_type" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_number" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_type" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_connections_account" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'FinancialConnectionsAccount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("routing_number" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'RoutingNumber obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_holder_type" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_number" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_type" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_connections_account" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'FinancialConnectionsAccount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("routing_number" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'RoutingNumber obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'" (\obj -> ((((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "account_holder_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "account_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "account_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "financial_connections_account")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "routing_number"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount' :: PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'
mkPostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount' =
  PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'
    { postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountNumber = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'FinancialConnectionsAccount = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'RoutingNumber = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.us_bank_account.properties.account_holder_type@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"company"@
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'EnumCompany
  | -- | Represents the JSON value @"individual"@
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'EnumIndividual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'EnumCompany) = "company"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'EnumIndividual) = "individual"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "company" -> PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'EnumCompany
            | val GHC.Classes.== "individual" -> PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'EnumIndividual
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountHolderType'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_data.properties.us_bank_account.properties.account_type@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"checking"@
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'EnumChecking
  | -- | Represents the JSON value @"savings"@
    PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'EnumSavings
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'EnumChecking) = "checking"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'EnumSavings) = "savings"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "checking" -> PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'EnumChecking
            | val GHC.Classes.== "savings" -> PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'EnumSavings
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodData'UsBankAccount'AccountType'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options@ in the specification.
--
-- Payment-method-specific configuration for this SetupIntent.
data PostSetupIntentsRequestBodyPaymentMethodOptions' = PostSetupIntentsRequestBodyPaymentMethodOptions'
  { -- | acss_debit
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'),
    -- | card
    postSetupIntentsRequestBodyPaymentMethodOptions'Card :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'Card'),
    -- | link
    postSetupIntentsRequestBodyPaymentMethodOptions'Link :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'Link'),
    -- | sepa_debit
    postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'),
    -- | us_bank_account
    postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("acss_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("card" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("link" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Link obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("us_bank_account" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("acss_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("card" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("link" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Link obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("us_bank_account" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'" (\obj -> ((((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "acss_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "card")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "link")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sepa_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "us_bank_account"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions' :: PostSetupIntentsRequestBodyPaymentMethodOptions'
mkPostSetupIntentsRequestBodyPaymentMethodOptions' =
  PostSetupIntentsRequestBodyPaymentMethodOptions'
    { postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'Link = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit' = PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'
  { -- | currency
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'),
    -- | mandate_options
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'),
    -- | verification_method
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("currency" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("currency" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'" (\obj -> ((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "mandate_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verification_method"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit' :: PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit' =
  PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'
    { postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.currency@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"cad"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumCad
  | -- | Represents the JSON value @"usd"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumUsd
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumCad) = "cad"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumUsd) = "usd"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "cad" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumCad
            | val GHC.Classes.== "usd" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumUsd
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' = PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'
  { -- | custom_mandate_url
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants),
    -- | default_for
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor :: (GHC.Maybe.Maybe ([PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'])),
    -- | interval_description
    --
    -- Constraints:
    --
    -- * Maximum length of 500
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | payment_schedule
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'),
    -- | transaction_type
    postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_mandate_url" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_for" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_description" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_schedule" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction_type" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_mandate_url" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_for" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_description" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_schedule" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction_type" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'" (\obj -> ((((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "custom_mandate_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "default_for")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "interval_description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_schedule")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "transaction_type"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' :: PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' =
  PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'
    { postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options.properties.custom_mandate_url.anyOf@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants
  = -- | Represents the JSON value @""@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'EmptyString
  | PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'EmptyString
        | GHC.Base.otherwise -> case (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options.properties.default_for.items@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"invoice"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'EnumInvoice
  | -- | Represents the JSON value @"subscription"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'EnumSubscription
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'EnumInvoice) = "invoice"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'EnumSubscription) = "subscription"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "invoice" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'EnumInvoice
            | val GHC.Classes.== "subscription" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'EnumSubscription
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'DefaultFor'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options.properties.payment_schedule@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"combined"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumCombined
  | -- | Represents the JSON value @"interval"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumInterval
  | -- | Represents the JSON value @"sporadic"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumSporadic
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumCombined) = "combined"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumInterval) = "interval"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumSporadic) = "sporadic"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "combined" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumCombined
            | val GHC.Classes.== "interval" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumInterval
            | val GHC.Classes.== "sporadic" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumSporadic
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options.properties.transaction_type@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumBusiness
  | -- | Represents the JSON value @"personal"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumPersonal
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumBusiness) = "business"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumPersonal) = "personal"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumBusiness
            | val GHC.Classes.== "personal" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumPersonal
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.verification_method@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumAutomatic
  | -- | Represents the JSON value @"instant"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumInstant
  | -- | Represents the JSON value @"microdeposits"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumMicrodeposits
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumAutomatic) = "automatic"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumInstant) = "instant"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumMicrodeposits) = "microdeposits"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumAutomatic
            | val GHC.Classes.== "instant" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumInstant
            | val GHC.Classes.== "microdeposits" -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumMicrodeposits
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.card@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'Card' = PostSetupIntentsRequestBodyPaymentMethodOptions'Card'
  { -- | mandate_options
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'),
    -- | request_three_d_secure
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("request_three_d_secure" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("request_three_d_secure" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'Card'" (\obj -> (GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'Card' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "mandate_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "request_three_d_secure"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'Card'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'Card' :: PostSetupIntentsRequestBodyPaymentMethodOptions'Card'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'Card' =
  PostSetupIntentsRequestBodyPaymentMethodOptions'Card'
    { postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.card.properties.mandate_options@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions' = PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'
  { -- | amount
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Amount :: GHC.Types.Int,
    -- | amount_type
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType :: PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType',
    -- | currency
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Currency :: Data.Text.Internal.Text,
    -- | description
    --
    -- Constraints:
    --
    -- * Maximum length of 200
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Description :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | end_date
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'EndDate :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | interval
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval :: PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval',
    -- | interval_count
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'IntervalCount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | reference
    --
    -- Constraints:
    --
    -- * Maximum length of 80
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Reference :: Data.Text.Internal.Text,
    -- | start_date
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'StartDate :: GHC.Types.Int,
    -- | supported_types
    postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes :: (GHC.Maybe.Maybe ([PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes']))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Amount obj] : ["amount_type" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType obj] : ["currency" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Currency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Description obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("end_date" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'EndDate obj) : ["interval" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_count" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'IntervalCount obj) : ["reference" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Reference obj] : ["start_date" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'StartDate obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("supported_types" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Amount obj] : ["amount_type" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType obj] : ["currency" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Currency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Description obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("end_date" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'EndDate obj) : ["interval" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_count" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'IntervalCount obj) : ["reference" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Reference obj] : ["start_date" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'StartDate obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("supported_types" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'" (\obj -> (((((((((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "end_date")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "interval")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "interval_count")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "reference")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "start_date")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "supported_types"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions' ::
  -- | 'postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Amount'
  GHC.Types.Int ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'
  PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType' ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Currency'
  Data.Text.Internal.Text ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'
  PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval' ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Reference'
  Data.Text.Internal.Text ->
  -- | 'postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'StartDate'
  GHC.Types.Int ->
  PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions' postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Amount postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Currency postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Reference postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'StartDate =
  PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'
    { postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Amount = postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Amount,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType = postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Currency = postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Currency,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Description = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'EndDate = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval = postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'IntervalCount = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Reference = postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Reference,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'StartDate = postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'StartDate,
      postSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.card.properties.mandate_options.properties.amount_type@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"fixed"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'EnumFixed
  | -- | Represents the JSON value @"maximum"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'EnumMaximum
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'EnumFixed) = "fixed"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'EnumMaximum) = "maximum"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "fixed" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'EnumFixed
            | val GHC.Classes.== "maximum" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'EnumMaximum
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'AmountType'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.card.properties.mandate_options.properties.interval@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"day"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumDay
  | -- | Represents the JSON value @"month"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumMonth
  | -- | Represents the JSON value @"sporadic"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumSporadic
  | -- | Represents the JSON value @"week"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumWeek
  | -- | Represents the JSON value @"year"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumYear
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumDay) = "day"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumMonth) = "month"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumSporadic) = "sporadic"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumWeek) = "week"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumYear) = "year"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "day" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumDay
            | val GHC.Classes.== "month" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumMonth
            | val GHC.Classes.== "sporadic" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumSporadic
            | val GHC.Classes.== "week" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumWeek
            | val GHC.Classes.== "year" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'EnumYear
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'Interval'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.card.properties.mandate_options.properties.supported_types.items@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"india"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'EnumIndia
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'EnumIndia) = "india"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "india" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'EnumIndia
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'MandateOptions'SupportedTypes'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.card.properties.request_three_d_secure@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"any"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'EnumAny
  | -- | Represents the JSON value @"automatic"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'EnumAutomatic
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'EnumAny) = "any"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'EnumAutomatic) = "automatic"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "any" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'EnumAny
            | val GHC.Classes.== "automatic" -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'EnumAutomatic
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'Card'RequestThreeDSecure'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.link@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'Link' = PostSetupIntentsRequestBodyPaymentMethodOptions'Link'
  { -- | persistent_token
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodOptions'Link'PersistentToken :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Link' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("persistent_token" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Link'PersistentToken obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("persistent_token" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'Link'PersistentToken obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'Link' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'Link'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'Link' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "persistent_token"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'Link'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'Link' :: PostSetupIntentsRequestBodyPaymentMethodOptions'Link'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'Link' = PostSetupIntentsRequestBodyPaymentMethodOptions'Link' {postSetupIntentsRequestBodyPaymentMethodOptions'Link'PersistentToken = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.sepa_debit@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit' = PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'
  { -- | mandate_options
    postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'MandateOptions :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'MandateOptions obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'MandateOptions obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "mandate_options"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit' :: PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit' = PostSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit' {postSetupIntentsRequestBodyPaymentMethodOptions'SepaDebit'MandateOptions = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.us_bank_account@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount' = PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'
  { -- | financial_connections
    postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'),
    -- | networks
    postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'),
    -- | verification_method
    postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod :: (GHC.Maybe.Maybe PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_connections" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("networks" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_connections" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("networks" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'" (\obj -> ((GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "financial_connections")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "networks")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verification_method"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount' :: PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount' =
  PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'
    { postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.us_bank_account.properties.financial_connections@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections' = PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'
  { -- | permissions
    postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions :: (GHC.Maybe.Maybe ([PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'])),
    -- | return_url
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'ReturnUrl :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("permissions" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'ReturnUrl obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("permissions" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'ReturnUrl obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'" (\obj -> (GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "permissions")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "return_url"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections' :: PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections' =
  PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'
    { postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions = GHC.Maybe.Nothing,
      postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'ReturnUrl = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.us_bank_account.properties.financial_connections.properties.permissions.items@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"balances"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumBalances
  | -- | Represents the JSON value @"ownership"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumOwnership
  | -- | Represents the JSON value @"payment_method"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumPaymentMethod
  | -- | Represents the JSON value @"transactions"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumTransactions
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumBalances) = "balances"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumOwnership) = "ownership"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumPaymentMethod) = "payment_method"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumTransactions) = "transactions"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "balances" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumBalances
            | val GHC.Classes.== "ownership" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumOwnership
            | val GHC.Classes.== "payment_method" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumPaymentMethod
            | val GHC.Classes.== "transactions" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'EnumTransactions
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'FinancialConnections'Permissions'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.us_bank_account.properties.networks@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks' = PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'
  { -- | requested
    postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested :: (GHC.Maybe.Maybe ([PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested']))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("requested" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("requested" Data.Aeson.Types.ToJSON..=)) (postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'" (\obj -> GHC.Base.pure PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "requested"))

-- | Create a new 'PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'' with all required fields.
mkPostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks' :: PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'
mkPostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks' = PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks' {postSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.us_bank_account.properties.networks.properties.requested.items@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ach"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'EnumAch
  | -- | Represents the JSON value @"us_domestic_wire"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'EnumUsDomesticWire
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'EnumAch) = "ach"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'EnumUsDomesticWire) = "us_domestic_wire"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ach" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'EnumAch
            | val GHC.Classes.== "us_domestic_wire" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'EnumUsDomesticWire
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'Networks'Requested'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.us_bank_account.properties.verification_method@ in the specification.
data PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumAutomatic
  | -- | Represents the JSON value @"instant"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumInstant
  | -- | Represents the JSON value @"microdeposits"@
    PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumMicrodeposits
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod' where
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'Other val) = val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumAutomatic) = "automatic"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumInstant) = "instant"
  toJSON (PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumMicrodeposits) = "microdeposits"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumAutomatic
            | val GHC.Classes.== "instant" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumInstant
            | val GHC.Classes.== "microdeposits" -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'EnumMicrodeposits
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyPaymentMethodOptions'UsBankAccount'VerificationMethod'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.single_use@ in the specification.
--
-- If this hash is populated, this SetupIntent will generate a single_use Mandate on success.
data PostSetupIntentsRequestBodySingleUse' = PostSetupIntentsRequestBodySingleUse'
  { -- | amount
    postSetupIntentsRequestBodySingleUse'Amount :: GHC.Types.Int,
    -- | currency
    postSetupIntentsRequestBodySingleUse'Currency :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodySingleUse' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodySingleUse'Amount obj] : ["currency" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodySingleUse'Currency obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodySingleUse'Amount obj] : ["currency" Data.Aeson.Types.ToJSON..= postSetupIntentsRequestBodySingleUse'Currency obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodySingleUse' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostSetupIntentsRequestBodySingleUse'" (\obj -> (GHC.Base.pure PostSetupIntentsRequestBodySingleUse' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency"))

-- | Create a new 'PostSetupIntentsRequestBodySingleUse'' with all required fields.
mkPostSetupIntentsRequestBodySingleUse' ::
  -- | 'postSetupIntentsRequestBodySingleUse'Amount'
  GHC.Types.Int ->
  -- | 'postSetupIntentsRequestBodySingleUse'Currency'
  Data.Text.Internal.Text ->
  PostSetupIntentsRequestBodySingleUse'
mkPostSetupIntentsRequestBodySingleUse' postSetupIntentsRequestBodySingleUse'Amount postSetupIntentsRequestBodySingleUse'Currency =
  PostSetupIntentsRequestBodySingleUse'
    { postSetupIntentsRequestBodySingleUse'Amount = postSetupIntentsRequestBodySingleUse'Amount,
      postSetupIntentsRequestBodySingleUse'Currency = postSetupIntentsRequestBodySingleUse'Currency
    }

-- | Defines the enum schema located at @paths.\/v1\/setup_intents.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.usage@ in the specification.
--
-- Indicates how the payment method is intended to be used in the future. If not provided, this value defaults to \`off_session\`.
data PostSetupIntentsRequestBodyUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostSetupIntentsRequestBodyUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostSetupIntentsRequestBodyUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"off_session"@
    PostSetupIntentsRequestBodyUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PostSetupIntentsRequestBodyUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostSetupIntentsRequestBodyUsage' where
  toJSON (PostSetupIntentsRequestBodyUsage'Other val) = val
  toJSON (PostSetupIntentsRequestBodyUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostSetupIntentsRequestBodyUsage'EnumOffSession) = "off_session"
  toJSON (PostSetupIntentsRequestBodyUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostSetupIntentsRequestBodyUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "off_session" -> PostSetupIntentsRequestBodyUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> PostSetupIntentsRequestBodyUsage'EnumOnSession
            | GHC.Base.otherwise -> PostSetupIntentsRequestBodyUsage'Other val
      )

-- | Represents a response of the operation 'postSetupIntents'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostSetupIntentsResponseError' is used.
data PostSetupIntentsResponse
  = -- | Means either no matching case available or a parse error
    PostSetupIntentsResponseError GHC.Base.String
  | -- | Successful response.
    PostSetupIntentsResponse200 SetupIntent
  | -- | Error response.
    PostSetupIntentsResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
